#!/usr/bin/python
# coding: utf-8
#
# Brunie nicolas, jeu basique
#
# War Of Blood , for more informations visit wobresurection.blogspot.com
 
VERSION = "0.4"
 
try:
  import random
  import math
  import pygame
  from Common import load_png
  from pygame.locals import *
  import sys
except ImportError, err:
  print "Impossible de charger le module. %s" % (err)
  sys.exit(2)
 

class Animation:
  """ gère une animation """
  def __init__(self,imageBase,imageList=[]):
    self.localFrame = 0
    self.timeUpdate = 250       # temps de rafraichissement
    self.tmpTime = 0
    if imageBase != None:
      self.imageBase,self.rect = load_png(imageBase)
    elif len(imageList) > 0:
      u,self.rect = load_png(imageList[0])
    self.frame = []
    for i in imageList:
      frame,rect = load_png(i)
      if imageBase != None:
        frame.blit(self.imageBase,(0,0))
      self.frame.append(frame)
    self.len = len(self.frame)

  def getUpdateFrame(self,time):
    self.tmpTime += time
    ret = 0
    if self.tmpTime > self.timeUpdate:
      self.tmpTime -= self.timeUpdate
      self.localFrame = (self.localFrame + 1) % self.len
      if self.localFrame == self.len - 1: ret = 1
    return self.frame[self.localFrame],ret

  def getRect(self):
    return self.rect

  def initialise(self):
    self.localFrame = 0
    self.tmpTime = 0
    
  def getFrame(self,i):
    return self.frame[i % self.len]
      
  def getLocalFrame(self):
    return self.frame[self.localFrame],0

class ModificablePicture(pygame.sprite.Sprite):
  def __init__(self,surface):
    pygame.sprite.Sprite.__init__(self)
    self.image,self.rect = surface,surface.get_rect()

  def changeImage(self,surface):
    x,y = self.rect.center
    self.image,self.rect = surface,surface.get_rect()
    self.rect.center = x,y

  def positionnement(self,x,y):
    self.rect.center = x,y

class AnimationOnScreen:
  def __init__(self,screen,imageBase,imageList=[]):
    self.localFrame = 0
    self.timeUpdate = 50
    self.tmpTime = 0
    if imageBase != None:
      self.imageBase,self.rect = load_png(imageBase)
    elif len(imageList) > 0:
      u,self.rect = load_png(imageList[0])
    self.frame = []
    for i in imageList:
      frame,rect = load_png(i)
      if imageBase != None:
        frame.blit(self.imageBase,(0,0))
      self.frame.append(frame)
    self.len = len(self.frame)
    self.group = pygame.sprite.Group()
    self.objet = ModificablePicture(self.frame[0])
    self.position = 0,0
    self.group.add(self.objet)
    self.screen = screen

  def renderUpdatedFrame(self,time):
    self.tmpTime += time
    ret = 0
    if self.tmpTime > self.timeUpdate:
      self.tmpTime -= self.timeUpdate
      if self.localFrame + 1 == self.len: ret = 1
      self.localFrame = (self.localFrame + 1) % self.len
      self.objet.changeImage(self.frame[self.localFrame])
    if not ret: self.group.draw(self.screen)
    return (1 - ret)

  def positionnement(self,x,y):
    self.position = x,y
    self.objet.positionnement(x,y)

  def initialise(self):
    self.localFrame = 0
    self.tmpTime = 0
    

class AnimationGestionner:
  def __init__(self):
    self.animations = {}
    self.activeAnimation = None
    self.boucle = 1
    self.endReached = 0
    self.side = 0

  def addAnimation(self,nom,imageBase,imageList):
    self.animations[nom] = Animation(imageBase,imageList)

  def changeSide(self,side):
    self.side = side

  def playAnimation(self,nom,boucle=1):
    if not nom in self.animations.keys():
      print "animation %s inconnue" % nom
      return 0
    if self.activeAnimation == nom: return 0 # l'animation est déjà en cours
    self.activeAnimation = nom
    self.animations[self.activeAnimation].initialise()
    self.boucle = boucle
    self.endReached = 0

  def getImage(self):
    img,ret = self.animations[self.activeAnimation].getLocalFrame()
    if self.side:
      return pygame.transform.flip(img,1,0)
    return img

  def getAnimationRect(self):
    return self.animations[self.activeAnimation].getRect()

  def getUpdatedImage(self,time,vitesse=1):
    if self.endReached and self.boucle == 0: tmp = 0
    else: tmp = 1
    img,ret = self.animations[self.activeAnimation].getUpdateFrame(tmp * time * vitesse)
    self.endReached = ret
    if self.side:
      return pygame.transform.flip(img,1,0)
    return img





class GlobalAnimationGestionner:
  def __init__(self,screen):
    self.spriteGroup = pygame.sprite.Group()
    self.animationGestionner = AnimationGestionner()

  def getAnimationGestionner(self):
    return self.animationGestionner

  def update(self,time):
    pass
