# -*- coding: utf-8 -*-
# Brunie Nicolas, War Of Blood

try:
  import random
  import math
  import pygame
  from Common import load_png
  from pygame.locals import *
  from Particle import *
  from Animation import *
  from Blast import Movable
  from CommonCharacter import CommonCharacter
except ImportError, err:
  print "Impossible de charger le module. %s" % (err)

invincibility = 1 # God 1 | jonas 0

class AvatarBadGuy(CommonCharacter):
  """Une balle qui se déplace sur lécran
  Retourne: objet ball
  Fonctions: update, calcnewpos
  Attributs: area, vector"""
 
  def __init__(self,gx,gy,camera,physicEngine):
    CommonCharacter.__init__(self,physicEngine)
    self.obstacle = None
    self.perso = None
    self.up = 400
    self.image, self.rect = load_png('man0.png')
    self.animation.addAnimation("defaut",None,["man0.png","man1.png"])
    self.animation.addAnimation("body",None,["body.png"])
    self.animation.playAnimation("defaut")
    screen = pygame.display.get_surface()
    self.activeMvt = "none"
    self.nextMvt = "none"
    self.a = 0
    self.inertie = 0
    self.en_lair = 0
    self.socle =  []
    self.equipement = None
    self.died = 0
    self.death_time = 0
    self.particles = {}
    cx,cy = camera.pos
    self.rect.center = gx - cx, gy - cy
    self.vector = 0,0 # x,y 
    
  def setId(self,idg,idl,idgHere):
    self.networkId = idg,idl
    self.hereId = idgHere
    
  def getHeadResume(self):
    return "badguychg %d %d" % self.networkId

  def forcedMove(self,dx,dy,obstacle):
    pass

  def renderAttachement(self,screen):
    pass

  def forcedMouvement(self,dx,dy):
    dx,dy = int(dx),int(dy)
    self.rect.move_ip(dx,dy)
    self.updateGlobalPosition(dx,dy)


  def updateGlobalPosition(self,dx,dy):
    gpx,gpy = self.globalpos
    self.globalpos = gpx+dx,gpy+dy

  def getGlobalPosition(self,dx,dy):
    return self.globalpos

  def looseHead(self,particleGestionner):
    self.died = 1
    bottom = self.rect.bottom
    center = self.rect.center
    #self.image, self.rect = self.body, self.body_rect
    self.animation.playAnimation("body")
    self.image = self.animation.getUpdatedImage(0)
    self.rect = self.animation.getAnimationRect()
    self.rect.center = center
    self.rect.bottom = bottom
    rate = 30
    ttl = 700
    number = 150
    bg = particleGestionner.background
    range = -9,10,-2,0
    life = 800 # None correspond a infini
    dx,dy = 0,-6
    x,y = self.rect.center
    ps = ParticleSystem(particleGestionner.screen,x,y,(dx,dy),rate,ttl,number,bg,range,life,back=0,tbo=70,immo=1,type="arterialBlood")
    self.particles["headBlood"] = particleGestionner.attach(ps)
    self.attach(ps,0,-20)

  def die(self,pg):
    pg.addPoint()
    if "headBlood" in self.particles.keys():
      pg.remove(self.particles["headBlood"])

  def looseLife(self,n,(x,y),pg,targets):
    # print n
    if self.getZone((x,y)) == 1:
      if self.life < 0:
        targets.remove(self)
        self.die(pg)
      if not self.died: self.looseHead(pg)
      self.life = - 10 
    else: 
    # if 1:
      self.life += n
      if self.life < 0:
        self.die(pg)
        print "die"
        targets.remove(self)

  def looseLife2(self,n):
    print n
    self.life += n
    if self.life < 0:
      #self.die(pg)
      print "die"
      self.kill()

  def attach(self,ob,dx,dy):
    x,y = self.rect.center
    self.attachement.append((ob,dx,dy))
    ob.positionnement(x+dx,y+dy)

  def getAttachement(self):
    return self.attachement

  def removeAll(self):
    self.attachement = []

  def defineMvt(self):
    x,y = self.perso.rect.center
    mx,my = self.rect.center
    if mx > x:
      return "left"
    else:
      return "right"

  def getZone(self,(x,y)):
    """ fonction pour déterminer la zone du corps touchée, et l'étendue des dégats 
        on sait déjà qu'il y a collision avec le sprite """
    mx,my = self.rect.center
    if y < my - 25:
      return 1
    else:
      return 0

  def setMvt(self):
    self.activeMvt = self.defineMvt()

  def jump(self,obstacle):
    if not pygame.sprite.spritecollide(self,obstacle,0):
      return 0
    vx,vy = self.vector
    vy -= 10
    self.vector = vx,vy

    
  def update(self,time,obstacle):
    return 1
    global invincibility
    if self.died:
      self.death_time -= time
    if self.perso.rect.colliderect(self.rect):
      #if not invincibility:
       self.perso.looseLife( -float(time) /float(2),(None,None),None,None)
    self.setMvt()
    self.image = self.animation.getUpdatedImage(time)
    if pygame.sprite.spritecollide(self,obstacle,0) and self.inertie:
      self.inertie = 0
      self.activeMvt = self.nextMvt
    # newpos = self.calcnewpos(self.rect,self.vector,time,obstacle)
    # self.rect = newpos
    vx,vy = self.vector
    if abs(vx) > 10: raw_input("stop")
    if self.activeMvt == "none":
      vx = float(vx) * 0.9
    elif self.activeMvt == "left": # and pygame.sprite.spritecollide(self,obstacle,0):
      if vx > -6: vx -= 0.2
    elif self.activeMvt == "right": # and pygame.sprite.spritecollide(self,obstacle,0):
      if vx < 6: vx += 0.2
    if self.physicEngine.getGroundDistance(self,self.rect) > 4: vy += 1
    self.vector = vx,vy
    #print "vx %d %d " % self.vector
    ndx,ndy = self.physicEngine.mouvement(self,vx,vy,caisse=1)
    if 1: self.vector = ndx,ndy    # 1 <-> update
    idx,idy = int(ndx),int(ndy)
    #print idx,idy
    self.rect.move_ip(idx,idy)
    self.updateGlobalPosition(idx,idy)


  def deplacement(self,dx,dy):
    self.rect.move_ip(dx,dy)
    for tob in self.attachement:
      ob,x,y = tob
      ob.deplacement(dx,dy)
 

  def positionnement(self,camera,ax,ay):
    gx,gy = self.globalpos
    dx,dy = ax-gx,ay-gy
    self.deplacement(dx,dy)
    self.updateGlobalPosition(dx,dy)

  def calcnewpos(self,rect,vector,time,obstacle):
    (dx,dy) = vector 
    lo = []
    for sp in obstacle.sprites():
      lo.append(sp.rect)
    self.socle = rect.move(0,dy).collidelistall(lo)
    if self.socle == []:
      dy += 0.3
      socle_y = 1000
    else:
      dy = 0
    collide_h = rect.move(dx,0).collidelistall(lo)
    for i in collide_h:
      if lo[i].top < self.rect.bottom - 2:
        dx = 0
        break
      
    self.vector = dx,dy
    for obp in self.attachement:
      ob,ox,oy = obp
      x,y = self.rect.center
      ob.positionnement(x+ox,oy+y)
    self.updateGlobalPosition(dx,dy)
    return rect.move(dx,dy)
