# -*- coding: utf-8 -*-
# Brunie Nicolas, War Of Blood

try:
  import random
  import math
  import pygame
  from Common import load_png
  from pygame.locals import *
  from Particle import *
  from Animation import *
  from Blast import Movable
  from CommonCharacter import CommonCharacter
  from Particle import ComplexParticleSystem
except ImportError, err:
  print "Impossible de charger le module. %s" % (err)

invincibility = 1 # God 1 | jonas 0

class BadGuy(CommonCharacter):
  """Une balle qui se déplace sur lécran
  Retourne: objet ball
  Fonctions: update, calcnewpos
  Attributs: area, vector"""
 
  def __init__(self, (x,y), (gx,gy), obstacle, perso,physicEngine,pg):
    CommonCharacter.__init__(self,physicEngine)
    self.obstacle = obstacle
    self.perso = perso
    self.up = 400
    self.image, self.rect = load_png('man0.png')
    self.animation.addAnimation("defaut",None,["badguy.1.0.png","badguy.1.1.png"])
    self.animation.addAnimation("body",None,["body.png"])
    self.animation.playAnimation("defaut")
    self.activeMvt = "none"
    self.nextMvt = "none"
    self.a = 0
    self.inertie = 0
    self.en_lair = 0
    self.socle =  []
    self.equipement = None
    self.died = 0
    self.death_time = 0
    self.particles = {}
    self.rect.center = x,y
    self.vector = 0,0 # x,y 
    self.particleGestionner = pg
    self.state = "en attente"
    self.tmpTime = 0
    self.objectifX = None
    # self.particleSystemInMove = []

  def forcedMove(self,dx,dy,obstacle):
    pass

  def getHeadResume(self):
    return "badguychg %d %d" % self.networkId

  def getGlobalPosition(self,dx,dy):
    return self.globalpos

  def looseHead(self,particleGestionner):
    self.died = 1
    bottom = self.rect.bottom
    center = self.rect.center
    self.animation.playAnimation("body")
    self.image = self.animation.getUpdatedImage(0)
    self.rect = self.animation.getAnimationRect()
    self.rect.center,self.rect.bottom = center,bottom
    rate = 30; ttl = 700; number = 150
    bg = particleGestionner.background
    range = -9,10,-2,0
    life = 800 # None correspond a infini
    dx,dy = 0,-6
    x,y = self.rect.center
    ps = ParticleSystem(particleGestionner.screen,x,y,(dx,dy),rate,ttl,number,bg,range,life,back=0,tbo=70,immo=1,type="arterialBlood")
    self.particles["headBlood"] = particleGestionner.attach(ps)
    self.attach(ps,0,-20)

  def setNetworkId(self,idg,idl):
    print "badguy new id %d %d " % (idg,idl)
    self.networkId = idg,idl

  def die(self,pg):
    pg.addPoint()
    if "headBlood" in self.particles.keys():
      pg.remove(self.particles["headBlood"])
      self.particles.pop("headBlood")

  def looseLife(self,n,(x,y),pg,targets):
    # print n
    if self.getZone((x,y)) == 1:
      if self.life < 0:
        targets.remove(self)
        self.die(pg)
      if not self.died: self.looseHead(pg)
      self.life = - 10 
    else: 
      self.life += n
      if self.life < 0:
        self.die(pg)
        targets.remove(self)

  def looseLife2(self,n):
    self.life += n
    if self.life < 0: self.kill()

  def attach(self,ob,dx,dy):
    x,y = self.rect.center
    self.attachement.append((ob,dx,dy))
    ob.positionnement(x+dx,y+dy)

  def getAttachement(self):
    return self.attachement

  def removeAll(self):
    self.attachement = []

  def getZone(self,(x,y)):
    """ fonction pour déterminer la zone du corps touchée, et l'étendue des dégats 
        on sait déjà qu'il y a collision avec le sprite """
    mx,my = self.rect.center
    if y < my - 25: return 1
    else: return 0

  def setMvt(self):
    self.activeMvt = self.defineMvt()

  def defineMvt(self):
    px,py = self.perso.rect.center
    mx,my = self.rect.center
    dx = (mx-px)
    dy = (my-py)
    if self.state == "en attente":
      if abs(dx) < 300 and abs(dy) < 100:
        self.state = "poursuite"
        # signe de surprise
        particle = ComplexParticleSystem(self.particleGestionner.screen,(mx,my-50),300,"icone.mood.png", 1.0,500) 
        self.particleGestionner.attach(particle)
      #if self.objectifX == None:
      #  self.objectifX = random.randrange(mx-200,mx+200) 
      return "none"
      # mouvement effectif
    elif self.state == "poursuite":
      if abs(dx) > 400 or abs(dy) > 120:
        self.state = "en attente"
        # signe d'interrogation
        particle = ComplexParticleSystem(self.particleGestionner.screen,(mx,my-50),300,"icone.interrogate.png", 1.0,500) 
        self.particleGestionner.attach(particle)
        # mouvement effectif
        return "none"
      if dx <  0: return "right"
      elif dx > 0: return "left"
      else: return "none"

  def jump(self,obstacle):
    if not pygame.sprite.spritecollide(self,obstacle,0): return 0
    vx,vy = self.vector
    vy -= 10
    self.vector = vx,vy

    
  def update(self,time,obstacle):
    global invincibility
    if self.died:
      self.death_time -= time
    self.tmpTime += time
    if self.perso.rect.colliderect(self.rect): 
      self.perso.looseLife( -float(time) /float(2),(None,None),None,None)
      if self.tmpTime > 100:
        self.tmpTime = 0
        mx,my = self.perso.rect.center
        dx = random.randrange(5,10) / 70.0 * random.randrange(-1,2,2)
        dy = random.randrange(5,10) / 70.0 * random.randrange(-1,2,2)
        particle = ComplexParticleSystem(self.particleGestionner.screen,(mx,my),300,"star.png", 1.0,500,direction=(dx,dy)) 
        self.particleGestionner.attach(particle)
    # mouvement en cours
    self.setMvt()
    # acquisition de l'image courante
    self.image = self.animation.getUpdatedImage(time)
    if pygame.sprite.spritecollide(self,obstacle,0) and self.inertie:
      self.inertie = 0
      self.activeMvt = self.nextMvt
    vx,vy = self.vector
    if self.activeMvt == "none": vx = float(vx) * 0.9
    elif self.activeMvt == "left" and vx > -3: vx -= 0.2
    elif self.activeMvt == "right" and vx < 3: vx += 0.2
    if self.physicEngine.getGroundDistance(self,self.rect) > 4: vy += 1
    self.vector = vx,vy
    ndx,ndy = self.physicEngine.mouvement(self,vx,vy,caisse=1)
    if 1: self.vector = ndx,ndy    # 1 <-> update
    idx,idy = int(ndx),int(ndy)
    self.rect.move_ip(idx,idy)
    self.updateGlobalPosition(idx,idy)
    # on deplace le sang attache au BadGuy
    if "headBlood" in self.particles.keys():
      self.particleGestionner.moveParticle(self.particles["headBlood"],idx,idy)
    # mise à jour de la liste reseau
    self.listResume.append("pos %d %d" % self.globalpos)
 
  def deplaceAttachement(self,dx,dy):
    for tob in self.attachement:
      ob,x,y = tob
      ob.deplacement(dx,dy)

  def deplacement(self,dx,dy,initial=None):
    if initial != None:
      self.updateGlobalPosition(dx,dy)
    self.rect.move_ip(dx,dy)
    self.deplaceAttachement(dx,dy)
    if "headBlood" in self.particles.keys():
      self.particleGestionner.moveParticle(self.particles["headBlood"],dx,dy)

