# -*- coding: utf-8 -*-
#
# Brunie Nicolas, War Of Blood


try:
  import pygame
  import sys
  import threading
  import Queue
  from pygame.locals import *
  from numpy import *
  from Angle import *
except ImportError, err:
  print "Impossible de charger le module. %s" % (err)
  sys.exit(2)


class Path:
  def __init__(self,obstacle,cible,longueur,largeur,pas,camera):
    self.obstacle = obstacle # Group de sprites qui ne sont pas traversables
    self.cible = cible # cible que l'on cherche à atteindre
    self.camera = camera
    self.tableau = reshape(array([0]*(longueur*largeur)),(longueur,largeur))
    self.longueur = longueur / pas
    self.largeur = largeur /pas
    self.pas = pas
    self.pointList = []

  def transCoords(self,(x,y)):
    """ on veut transformer les coordonnes x,y en coordonnes d'affichage pour l'ecran """
    cx,cy = self.camera.pos
    return x-cx,y-cy

  def createRepresentation(self,cx,cy):
    """ (cx,cy) origine du tableau, on fait une division par carré de _pas_ de coté 
        pour être juste, cette fonction doit être appelée avant tout mouvement de camera
      """
    self.origine = cx,cy
    pas = self.pas
    rectList = []
    for sp in self.obstacle.sprites():
      rectList.append(sp.rect)
    for x in range(self.longueur):
      for y in range(self.largeur):
        rect = Rect((x*pas-pas/2+cx,y*pas-pas/2+cy),(pas,pas))
        if rect.collidelist(rectList) != -1:
          self.tableau[x][y] = 0
        else: 
          self.tableau[x][y] = 1
          self.pointList.append((x*pas,y*pas))

  def affiche(self,screen):
    cx,cy = self.camera.pos
    ox,oy = self.origine
    for a in self.pointList:
      x,y = a
      x += cx+ox
      y += cy+oy
      pygame.draw.circle(screen,(100,100,100),(x,y),4)

  def getVoisin(self,elt): #,tableau):
    x,y = elt
    liste = []
    if x != 0:
      liste.append((x-1,y)) #tableau[x-1][y])
    if y != 0:
      liste.append((x,y-1)) #tableau[x][y-1])
    if x != self.longueur - 1:
      liste.append((x+1,y)) #tableau[x+1][y])
    if y != self.largeur - 1:
      liste.append((x,y+1)) #tableau[x][y+1])
    return liste

  def printChemin2(self,chemin,screen):
    pas = self.pas
    liste = []
    for i in chemin:
      liste.append(i)
    cx,cy = self.camera.pos
    while len(liste) >= 2:
      xo,yo = liste.pop(0)
      xd,yd = liste[0]
      xo = xo*pas+cx 
      yo = yo*pas+cy
      xd = xd*pas+cx
      yd = yd*pas+cy

  def printChemin(self,chemin,screen):
    pas = 1
    liste = []
    for i in chemin:
      liste.append(i)
    cx,cy = self.camera.pos
    while len(liste) >= 2:
      xo,yo = liste.pop(0)
      xd,yd = liste[0]
      xo = xo*pas+cx 
      yo = yo*pas+cy
      xd = xd*pas+cx
      yd = yd*pas+cy
      pygame.draw.line(screen,(100,100,100),(xo,yo),(xd,yd),4)
      pygame.draw.circle(screen,(255,0,0),(xd,yd),8)
      
  def angle(self,a,b,c):
    xa,ya = a
    xc,yc = c
    xb,yb = b
    vx,vy = (xc - xa, yc - ya)
    v2x,v2y = (xb-xa,yb-ya)
    a1 = angle(v2x,v2y)
    a2 = angle(vx,vy)
    return a2 - a1


  def angleMax(self,chemin):
    """ retourne l'angle max de ce chemin ainsi qu'une liste qui correspond au chemin """
    max = 0
    for i in range(len(chemin) - 2):
      a = abs(self.angle(chemin[i],chemin[i+1],chemin[i+2]))
      if a > 180:
        a = abs(a - 360)
      if a > max:
        max = a
    liste = []
    for e in chemin:
      liste.append(e)
    return max,liste

  def milieu(self,pa,pb):
    xa,ya = pa
    xb,yb = pb
    x = (xa + xb) / 2
    y = (ya + yb) / 2
    return x,y

  def isOutObstacle2(self,(x,y)):
    for sp in self.obstacle.sprites():
      if sp.rect.collidepoint((x,y)):
        return 0
    return 1
  
  def isOutObstacle(self,(x,y)):
    ox,oy = self.origine
    px = x - ox
    py = y - oy
    px = px / self.pas
    py = py / self.pas
    return self.tableau[px][py]

  def simplify(self,chemin):
    liste = []
    for e in chemin:
      liste.append(e)
    result = []
    while len(liste) > 2:
      x1,y1 = liste[0]
      x2,y2 = liste[1]
      x3,y3 = liste[2]
      a1 = angle(x2 - x1, y2 -y1)
      a2 = angle(x3 - x2, y3 - y2)
      if a1 == a2:
        l = liste.pop(1)
      else:
        result.append(liste.pop(0))
    return (result + liste)

  def double(self,chemin):
    point = chemin[0]
    liste = [point]
    for i in chemin[1:]: 
      liste.append(self.milieu(point,i))
      liste.append(i)
      point = i
    return liste
      
  def lineNotCollideObstacle(self,pa,pb):
    liste = [pa,pb]
    for i in range(8):
      liste = self.double(liste)
    for p in liste:
      if not self.isOutObstacle(p):
        return 0
    return 1
        

  def raffinePath(self,chemin):
    """ raffinement de chemin : on arrondit les angles """
    if len(chemin) <= 2:
      return chemin
    liste2 = []
    for a in chemin:
      c,d = a
      liste2.append((c,d))
    angleMax,liste = self.angleMax(liste2)
    liste = self.simplify(liste)
    liste = self.double(liste)
    for j in range(10):
      for i in range(len(liste) - 2):
        point = self.milieu(liste[i],liste[i+2])
        if self.lineNotCollideObstacle(liste[i],liste[i+2]):
          liste[i+1] = point
    return liste  
      
    

  def findPath(self,xo,yo,xd,yd):
    longueur = self.longueur
    largeur = self.largeur
    cx,cy = self.origine
    xo = xo - cx
    yo = yo -cy
    xd -= cx
    yd -= cy
    xo /= self.pas
    yo /= self.pas
    xd  /= self.pas
    yd /= self.pas
    liste = [(xo,yo)]
    tableau = reshape(array([None]*(longueur*largeur)),(longueur,largeur))
    tableau[xo][yo] = (0,None) # distance, prédecesseur
    while 1:
      # print liste
      liste.sort()
      if liste == []:
        break
      xe,ye = liste.pop(0)
      if xe == xd and ye == yd:
        break
      dist,rien = tableau[xe][ye]
      for v in self.getVoisin((xe,ye)):
        xv,yv = v
        if self.tableau[xv][yv] == 0:     # zone non accessible
          continue
        c = tableau[xv][yv]
        if c == None:
          tableau[xv][yv] = (dist+1,(xe,ye))
          liste.append((xv,yv))
        else:
          dv,p = c
          if dv > dist + 1: 
            tableau[xv][yv] = (dist+1,(xe,ye))
            liste.append((xv,yv))
    xtmp,ytmp = xd,yd
    chemin = []
    while (xtmp,ytmp) !=  (xo,yo) and tableau[xtmp][ytmp] != None:
      d,pred = tableau[xtmp][ytmp]
      chemin.append(pred)
      xtmp,ytmp = pred
    liste = []
    for e in chemin:
      x,y = e
      liste.append((x*self.pas+cx,y*self.pas+cy))
    return liste

        
    

class ThreadPath(threading.Thread):
  def __init__(self,obstacle,perso,width,height,pas,camera,origine):
    threading.Thread.__init__(self)
    self.pathModule = Path(obstacle,perso,width,height,pas,camera)
    self.pathModule.createRepresentation(origine[0],origine[1])
    self.requestQueue = Queue.Queue()
    self.answer = {}
    self.id = 1

  def askPath(self,xo,yo,xd,yd):
    id = self.id
    self.requestQueue.put((id,(xo,yo,xd,yd)))
    self.id += 1
    return id

  def getPath(self,id):
    if id in self.answer.keys():
      return self.answer[id]
    else:
      return None

  def arreter(self):
    self.requestQueue.put((0,(0,0,0,0)))
    

  def run(self):
    while 1:
      (id,(xo,yo,xd,yd)) = self.requestQueue.get()
      if id == 0:
        break
      chemin = self.pathModule.findPath(xo,yo,xd,yd)
      chemin = self.pathModule.raffinePath(chemin)
      self.answer[id] = chemin
    print "arret du thread"

  


