# coding: utf-8
#
# Brunie nicolas, War Of Blood, for more information visit wobresurection.blogspot.com
#
 
 
try:
  import math
  import os
  import pygame
  from pygame.locals import *
  import sys
except ImportError, err:
  print "Impossible de charger le module. %s" % (err)
  sys.exit(2)

def vectdist2((vx,vy)):
  return math.sqrt(vx**2+vy**2)
 
def load_png(name):
  """Charge une image et retourne un objet image"""
  fullname = os.path.join('data', name)
  try:
    image = pygame.image.load(fullname)
    if image.get_alpha is None:
      image = image.convert()
    else:
      image = image.convert_alpha()
  except pygame.error, message:
    print "Impossible de charger l'image : ", fullname
    raise SystemExit, message
  return image, image.get_rect()
 
 
class Picture(pygame.sprite.Sprite):
  """Une balle qui se déplace sur lécran
  Retourne: objet ball
  Fonctions: update, calcnewpos
  Attributs: area, vector"""

  def __init__(self, (x,y), image,scale = 1.0,id=0):
    self.up = 400
    self.general_time = 0
    pygame.sprite.Sprite.__init__(self)
    self.image, self.rect = load_png(image)
    l,h = self.rect.width, self.rect.height
    self.rect.move_ip(x,y)
    self.id = id
    if scale != 1.0:
      self.image = pygame.transform.scale(self.image,(int(l*scale),int(h*scale)))
      self.rect.move_ip((1-scale)*l/2,(1-scale)*h/2)


def determineAngle(dx,dy):
  if dx == 0:
    if dy > 0:
      return 90
    else:
      return -90
  angle = math.atan(abs(dy) / abs(dx))
  angle = 180.0 * angle / math.pi
  if dy == 0: return 0
  elif dx > 0: return  - abs(dy) / dy * angle # math.atan(abs(dy) / abs(dx))
  elif dx < 0: return  abs(dy) / dy * angle # math.atan(abs(dy) / abs(dx))
  if 1: 
    pass
  else:
    angle = math.atan(abs(dy) / abs(dx))
    angle = 180.0 * angle / math.pi
    if dx < 0 and dy > 0:
      angle += 180.0
    elif dx < 0 and dy < 0:
      angle = 180.0 - angle # 180.0
    elif dx > 0 and dy > 0:
      angle = - angle
    return angle

class Object(pygame.sprite.Sprite):
  """Une balle qui se déplace sur lécran
  Retourne: objet ball
  Fonctions: update, calcnewpos
  Attributs: area, vector"""

  def __init__(self, (x,y), image,id=0):
    self.up = 400
    self.general_time = 0
    pygame.sprite.Sprite.__init__(self)
    self.image, self.rect = load_png(image)
    self.image_origine = self.image
    self.rect_origine = self.rect
    self.rect.move_ip(x,y)
    self.id = id
    self.angle = 0
    self.tmp = 0
    self.side = 0

  def setId(self,id):
    self.id = id

  def deplacement(self,dx,dy):
    self.rect.move_ip(dx,dy)

  def positionnement(self,x,y):
    cx,cy = self.rect.center
    self.deplacement(x-cx,y-cy)

  def rotationAngle(self,angle):
    x,y = self.rect.center
    self.image = pygame.transform.rotate(self.image_origine,angle)
    self.rect = self.image.get_rect()
    cx,cy = self.rect.center
    self.rect.move_ip(x - cx, y - cy)
    self.angle = angle
    
  def getCenter(self):
    return self.rect.center

  def update(self,time):
    pass

  def rotation(self,dx,dy):
    angle = determineAngle(dx,dy)
    a = angle - self.angle
    if abs(a) >  0.1: 
      x,y = self.rect.center
      self.image = pygame.transform.rotate(self.image_origine,angle)
      self.rect = self.image.get_rect()
      cx,cy = self.rect.center
      self.rect.move_ip(x - cx, y - cy)
      self.angle = angle
    if dx > 0 and self.side == 1:
      self.side = 0
      self.image = pygame.transform.flip(self.image,1,0)
      self.image_origine = pygame.transform.flip(self.image_origine,1,0)
    elif dx < 0 and self.side == 0:
      self.side = 1
      self.image = pygame.transform.flip(self.image,1,0)
      self.image_origine = pygame.transform.flip(self.image_origine,1,0)

class FusionGroup(pygame.sprite.Group):
  def __init__(self,*groups):
    pygame.sprite.Group.__init__(self)
    self.liste = list(groups)


  def appendGroup(self,group):
    self.liste.append(group)

  def draw(self,screen):
    for group in self.liste:
      group.draw(screen)

  def update(self,*args):
    for group in self.liste:
      group.update(*args)

  def remove(self,sprite):
    for group in self.liste:
      group.remove(sprite)
    

  def sprites(self):
    l = []
    for group in self.liste:
      l += group.sprites()
    return l

class CompositeGroup(pygame.sprite.Group):
  """ on forme un groupe dans lequel les items peuvent changer d'état """
  def __init__(self,*sprites):
    pygame.sprite.Group.__init__(self)
    self.activeGroup = list(sprites)
    self.unactiveGroup = []

  def draw(self,screen):
    for sp in self.activeGroup:
      screen.blit(sp.image,sp.rect)

  def update(self,*args):
    l = []
    for sp in self.activeGroup:
      if not sp.update(*args):
        #self.activeGroup.remove(sp)
        self.unactiveGroup.append(sp)
      else: l.append(sp)
    self.activeGroup = l
    l = []
    for sp in self.unactiveGroup:
      if sp.update(*args):
        # self.unactiveGroup.remove(sp)
        self.activeGroup.append(sp)
      else: l.append(sp)
    self.unactiveGroup = l

  def sprites(self):
    return self.unactiveGroup + self.activeGroup
