# -*- coding: utf-8 -*- 
#
# Brunie nicolas, War Of Blood, 
# for more information visit http://wobresurection.blogspot.com
#
 
try:
  import math
  import os
  import pygame
  from pygame.locals import *
  import sys
except ImportError, err:
  print "Impossible de charger le module. %s" % (err)
  sys.exit(2)

def vectdist2((vx,vy)):
  return math.sqrt(vx**2+vy**2)
 
def load_png(name):
  """Charge une image et retourne un objet image"""
  fullname = os.path.join('data', name)
  try:
    image = pygame.image.load(fullname)
    if image.get_alpha is None:
      image = image.convert()
    else:
      image = image.convert_alpha()
  except pygame.error, message:
    print "Impossible de charger l'image : ", fullname
    raise SystemExit, message
  return image, image.get_rect()
 


class LevelObject(pygame.sprite.Sprite):
  """Une balle qui se déplace sur lécran
  Retourne: objet ball
  Fonctions: update, calcnewpos
  Attributs: area, vector"""

  def __init__(self, (gx,gy), image,type,id=0):
    self.up = 400
    self.general_time = 0
    pygame.sprite.Sprite.__init__(self)
    self.img = image
    self.image, self.rect = load_png(image)
    self.image_origine = self.image
    self.rect_origine = self.rect
    self.rect.move_ip(gx,gy)
    self.globalPos = gx,gy
    self.id = id
    self.angle = 0
    self.tmp = 0
    self.side = 0
    self.type = type
    self.scale = 1.0

  def getDescription(self):
    return self.type

  def deplacement(self,x,y,cameraMove=None):
    self.rect.move_ip(int(x),int(y))
    vx = x / self.scale
    vy = y / self.scale
    # si c'est juste un mvt de camera, la position globale n'est pas modifié
    if cameraMove == None: self.globalPos = vx + self.globalPos[0], vy + self.globalPos[1]

  def copy(self):
    sp = LevelObject(self.globalPos,self.img,self.type)
    return sp

  def setId(self,id):
    self.id = id

  def positionnement(self,x,y):
    cx,cy = self.rect.center
    self.deplacement(x-cx,y-cy)

  def rotationAngle(self,angle):
    x,y = self.rect.center
    self.image = pygame.transform.rotate(self.image_origine,angle)
    self.rect = self.image.get_rect()
    cx,cy = self.rect.center
    self.rect.move_ip(x - cx, y - cy)
    self.angle = angle
    
  def getCenter(self):
    return self.rect.center

  def update(self,time):
    pass

  def rotation(self,dx,dy):
    angle = determineAngle(dx,dy)
    a = angle - self.angle
    if abs(a) >  0.1: 
      x,y = self.rect.center
      self.image = pygame.transform.rotate(self.image_origine,angle)
      self.rect = self.image.get_rect()
      cx,cy = self.rect.center
      self.rect.move_ip(x - cx, y - cy)
      self.angle = angle
    if dx > 0 and self.side == 1:
      self.side = 0
      self.image = pygame.transform.flip(self.image,1,0)
      self.image_origine = pygame.transform.flip(self.image_origine,1,0)
    elif dx < 0 and self.side == 0:
      self.side = 1
      self.image = pygame.transform.flip(self.image,1,0)
      self.image_origine = pygame.transform.flip(self.image_origine,1,0)
