#!/usr/bin/python
# coding: utf-8
#
# Brunie nicolas, War Of Blood
#
# for more informations, visit wobresurection.blogspot.com

 
try:
  import math
  import pygame
  from Common import Object,load_png
  from Perso import *
  from Particle import *
  from pygame.locals import *
  from Weapons import Bullet,Explosion, Explosion2
  import sys
except ImportError, err:
  print "Impossible de charger le module. %s" % (err)
  sys.exit(2)
 

class Brick(pygame.sprite.Sprite):
  def __init__(self, (x,y), vector,scale=1,coords=None,img='block0.png',angle=0):
    pygame.sprite.Sprite.__init__(self)
    self.image, self.rect = load_png(img)
    self.image_origine,a = load_png(img)
    self.image = pygame.transform.rotozoom(self.image,0,scale)
    # on applique la rotation avant de charger le rectangle
    self.image = pygame.transform.rotate(self.image,angle)
    self.image_origine = pygame.transform.rotate(self.image_origine,angle)
    self.img = img
    self.rect = self.image.get_rect()
    screen = pygame.display.get_surface()
    self.area = screen.get_rect()
    self.rect = self.rect.move(x,y)
    self.scale = scale
    self.angle = angle
    if coords != None: self.globalPos = coords
    else: self.globalPos = x,y
  
  def getDescription(self):
    return "brick"

  def rotation(self,angle):
    self.angle += angle
    self.image = pygame.transform.rotate(self.image,angle)
    self.image_origine = pygame.transform.rotate(self.image_origine,angle)
    t,l = self.rect.top,self.rect.left
    self.rect = self.image.get_rect() #.move(x,y)
    self.rect.top = t
    self.rect.left = l 


  def deplacement(self,x,y,cameraMove=None):
    self.rect.move_ip(int(x),int(y))
    vx = x / self.scale
    vy = y / self.scale
    # si c'est juste un mvt de camera, la position globale n'est pas modifié
    if cameraMove == None: self.globalPos = vx + self.globalPos[0], vy + self.globalPos[1]

  def copy(self):
    sp = Brick((self.rect.left,self.rect.top),(0,0),scale=self.scale,coords = self.globalPos,img=self.img,angle=self.angle)
    return sp


class ApparitionDoor(pygame.sprite.Sprite):
  def __init__(self, (x,y), vector,scale=1,coords=None,img="porte.png",angle=0):
    pygame.sprite.Sprite.__init__(self)
    self.img = "porte.png"
    self.image, self.rect = load_png(self.img)
    self.image_origine,a = load_png(self.img)
    self.image = pygame.transform.rotozoom(self.image,0,scale)
    # on applique la rotation avant de charger le rectangle
    self.image = pygame.transform.rotate(self.image,angle)
    self.image_origine = pygame.transform.rotate(self.image_origine,angle)
    self.rect = self.image.get_rect()
    screen = pygame.display.get_surface()
    self.area = screen.get_rect()
    self.rect = self.rect.move(x,y)
    self.scale = scale
    self.angle = angle
    if coords != None: self.globalPos = coords
    else: self.globalPos = x,y
  
  def getDescription(self):
    return "apparitiondoor"

  def rotation(self,angle):
    self.angle += angle
    self.image = pygame.transform.rotate(self.image,angle)
    self.image_origine = pygame.transform.rotate(self.image_origine,angle)
    # x,y = self.rect.center
    # self.rect = self.image.get_rect().move(x,y)
    t,l = self.rect.top, self.rect.left
    self.rect = self.image.get_rect()
    self.rect.top,self.rect.left = t,l


  def deplacement(self,x,y,cameraMove=None):
    self.rect.move_ip(x,y)
    vx = x / self.scale
    vy = y / self.scale
    # si c'est juste un mvt de camera, la position globale n'est pas modifié
    if cameraMove == None: self.globalPos = vx + self.globalPos[0], vy + self.globalPos[1]

  def copy(self):
    sp = ApparitionDoor(self.rect.center,(0,0),scale=self.scale,coords = self.globalPos,img=self.img,angle=self.angle)
    return sp



class SpaceDoor(pygame.sprite.Sprite):
  def __init__(self,(x,y),obstacle,perso,spriteGroup):
    pygame.sprite.Sprite.__init__(self)
    self.group = spriteGroup
    self.obstacle = obstacle
    self.perso = perso
    self.image, self.rect = load_png('block.png')
    screen = pygame.display.get_surface()
    self.area = screen.get_rect()
    self.rect = self.rect.move(x,y)
    self.rate = 3000
    self.tmp_time = 0

  def getDescrption(self):
    return "spacedoor"
  
  def deplacement(self,x,y):
    self.rect.move_ip(x,y)

  def update(self,time):
    self.tmp_time +=time
    if self.tmp_time > self.rate:
      if self.rate > 500: self.rate -= 50
      self.tmp_time = 0
      p = BadGuy((self.rect.center),(200,0),self.obstacle,self.perso)
      self.group.add(p)


class Ascensor(pygame.sprite.Sprite):
  def __init__(self,(x,y),h,perso):
    self.perso = perso
    pygame.sprite.Sprite.__init__(self)
    self.image, self.rect = load_png('block.png')
    screen = pygame.display.get_surface()
    self.area = screen.get_rect()
    self.rect = self.rect.move(x,y)
    self.rate = 3000
    self.tmp_time = 0
    self.origine_y = y
    self.target_y = y+h
    self.update_rate = 20
    self.state = 0
  
  def ascDeplacement(self,x,y):
    self.rect.move_ip(x,y)

  def deplacement(self,x,y):
    self.rect.move_ip(x,y)
    self.target_y += y
    self.origine_y += y

  def update(self,time):
    perso = self.perso
    self.tmp_time +=time
    while self.tmp_time > self.update_rate:
      self.tmp_time -= self.update_rate
      m = 0
      if self.state == 0:
        if self.rect.center[1] < self.target_y:
          self.ascDeplacement(0,1)
          m = 1
        else:
          self.state = 1
      elif self.state == 1:
        if self.rect.center[1] > self.origine_y:
          m = -1
          self.ascDeplacement(0,-1)
        else:
          self.state = 0
      if self.rect.colliderect(perso.rect):
        perso.deplacement(0,m)



class Tourelle(pygame.sprite.Sprite):
  def __init__(self, (x,y), vector,img,decTourelle,imageTourelle,perso,particleGestionner,coords=None,scale=1):
    pygame.sprite.Sprite.__init__(self)
    self.image, self.rect = load_png(img)
    self.image_origine,a = load_png(img)
    self.image = pygame.transform.rotozoom(self.image,0,scale)
    self.imageTourelle,self.rectTourelle = load_png(imageTourelle)
    self.imageTourelleOrigine = self.imageTourelle
    self.decTourelle = dx,dy = decTourelle
    self.tourelle = Object((x+dx,y+dy),imageTourelle,0)
    # on applique la rotation avant de charger le rectangle
    self.img = img
    self.rect = self.image.get_rect()
    screen = pygame.display.get_surface()
    self.area = screen.get_rect()
    self.rect = self.rect.move(x,y)
    #self.rectTourelle.move_ip(x+dx,y+dy)
    self.scale = scale
    self.angle = 0 # angle de la tourelle
    if coords != None: self.globalPos = coords
    else: self.globalPos = x,y
    self.timeSinceLastShoot = 0 
    self.perso = perso
    self.particleGestionner = particleGestionner
    self.structPoint = 1000

  def takeDamage(self,p):
    #print self.structPoint
    self.structPoint += p
    if self.structPoint < 0:
      self.destruct()

  def destruct(self):
    arg = {}
    arg["number"] = 10
    arg["pg"] = self.particleGestionner
    e = Explosion2(self.rect.center,arg)

  def getTourelle(self):
    return self.tourelle

  def getDescription(self):
    return "tourelle"

  def rotation(self,angle):
    self.tourelle.rotationAngle(angle)
    #self.angle = angle
    #self.imageTourelle = pygame.transform.rotate(self.imageTourelleOrigine,angle)
    #x,y = self.rect.center
    #dx,dy = self.decTourelle
    #self.rectTourelle = self.imageTourelle.get_rect().move(x+dx,y+dy)

  def deplacement(self,x,y,cameraMove=None):
    self.rect.move_ip(x,y)
    #self.rectTourelle.move_ip(x,y)
    self.tourelle.deplacement(x,y)
    vx = x / self.scale
    vy = y / self.scale
    # si c'est juste un mvt de camera, la position globale n'est pas modifié
    if cameraMove == None: self.globalPos = vx + self.globalPos[0], vy + self.globalPos[1]

  def positionnement(self,x,y):
    cx,cy = self.rect.center
    self.rect.move_ip(x-cx,y-cy)
    self.tourelle.positionnement(x,y)
    #self.rectTourelle.move_ip(x-cx,y-cy)

  def shoot(self,dx,dy):
    b = Bullet(10,(dx,dy),self.tourelle.getCenter(),self.particleGestionner,pygame.sprite.Group(self.perso))  # self.pos au lieu de self.perso.rect.center
    self.particleGestionner.attach(b)
  
  def update(self,time):
    self.timeSinceLastShoot += time
    # on met à jour l'orientation de la tourelle
    cx,cy = self.rect.center
    px,py = self.perso.rect.center
    d = math.sqrt((cy-py)**2+(cx-px)**2)
    if d > 500:
      return 1
    tx,ty = self.tourelle.getCenter()
    vx,vy = px-tx,py-ty
    d = math.sqrt(vx**2+vy**2)
    vx /= d
    vy /= d
    if vx == 0:
      if vy != 0:
        angle = abs(vy) / vy * 90
      else: angle = 0
    else:
      angle = math.atan(vy /vx)
    angle = angle * 180 / math.pi
    if vx > 0:
      angle = - angle
    else:
      angle += 180
      angle = -angle
    self.rotation(angle )
    # on en tire que si le temps de rechargement est dépassé
    if self.timeSinceLastShoot < 1000:
      return 1
    self.timeSinceLastShoot = 0
    self.shoot(vx * 80, vy * 80)


class RocketTourelle(pygame.sprite.Sprite):
  def __init__(self, (x,y), vector,img,decTourelle,imageTourelle,perso,particleGestionner,coords=None,scale=1):
    pygame.sprite.Sprite.__init__(self)
    self.image, self.rect = load_png(img)
    self.image_origine,a = load_png(img)
    self.image = pygame.transform.rotozoom(self.image,0,scale)
    self.imageTourelle,self.rectTourelle = load_png(imageTourelle)
    self.imageTourelleOrigine = self.imageTourelle
    self.decTourelle = dx,dy = decTourelle
    self.tourelle = Object((x+dx,y+dy),imageTourelle,0)
    # on applique la rotation avant de charger le rectangle
    self.img = img
    self.rect = self.image.get_rect()
    screen = pygame.display.get_surface()
    self.area = screen.get_rect()
    self.rect = self.rect.move(x,y)
    #self.rectTourelle.move_ip(x+dx,y+dy)
    self.scale = scale
    self.angle = 0 # angle de la tourelle
    if coords != None: self.globalPos = coords
    else: self.globalPos = x,y
    self.timeSinceLastShoot = 0 
    self.perso = perso
    self.particleGestionner = particleGestionner
    self.pathModule = None
    self.targetList = []
    self.pathId = []

  def attachModule(self,pathModule,targetList):
    self.idTarget = {}
    self.pathModule = pathModule
    self.targetList = targetList

  def getTourelle(self):
    return self.tourelle

  def getDescription(self):
    return "rockettourelle"

  def rotation(self,angle):
    self.tourelle.rotationAngle(angle)

  def deplacement(self,x,y,cameraMove=None):
    self.rect.move_ip(x,y)
    self.tourelle.deplacement(x,y)
    vx = x / self.scale
    vy = y / self.scale
    if cameraMove == None: self.globalPos = vx + self.globalPos[0], vy + self.globalPos[1]

  def positionnement(self,x,y):
    cx,cy = self.rect.center
    self.rect.move_ip(x-cx,y-cy)
    self.tourelle.positionnement(x,y)

  def shoot(self,dx,dy,target):
    direction = dx,dy

    b = Bullet(10,(dx,dy),self.tourelle.getCenter(),self.particleGestionner,pygame.sprite.Group(self.perso))  # self.pos au lieu de self.perso.rect.center
    self.particleGestionner.attach(b)
  
  def update(self,time):
    self.timeSinceLastShoot += time
    # on met à jour l'orientation de la tourelle
    cx,cy = self.rect.center
    px,py = self.perso.rect.center
    d = math.sqrt((cy-py)**2+(cx-px)**2)
    if d > 500:
      return 1
    tx,ty = self.tourelle.getCenter()
    vx,vy = px-tx,py-ty
    d = math.sqrt(vx**2+vy**2)
    vx /= d
    vy /= d
    if vx == 0:
      if vy != 0:
        angle = abs(vy) / vy * 90
      else: angle = 0
    else:
      angle = math.atan(vy /vx)
    angle = angle * 180 / math.pi
    if vx > 0:
      angle = - angle
    else:
      angle += 180
      angle = -angle
    self.rotation(angle )
    # on regarde si un tir est armé
    for id in self.pathId:
      chemin = self.pathModule.getPath(id)
      if chemin != None:
        self.pathId.remove(id)
        self.shoot(chemin,self.idTarget[id])
    # on en tire que si le temps de rechargement est dépassé
    if self.timeSinceLastShoot < 1000:
      return 1
    self.timeSinceLastShoot = 0
    self.shoot(vx * 80, vy * 80)


class OpeningDoor(pygame.sprite.Sprite):
  def __init__(self, (x,y,x_mobile,y1,y2),(imgImmobile,imgHaut,imageBas)):
    pygame.sprite.Sprite.__init__(self)
    self.image, self.rect = load_png(img)
    self.image_origine,a = load_png(img)
    self.image = pygame.transform.rotozoom(self.image,0,scale)
    # on applique la rotation avant de charger le rectangle
    self.image = pygame.transform.rotate(self.image,angle)
    self.image_origine = pygame.transform.rotate(self.image_origine,angle)
    self.img = img
    self.rect = self.image.get_rect()
    screen = pygame.display.get_surface()
    self.area = screen.get_rect()
    self.rect = self.rect.move(x,y)
    self.scale = scale
    self.angle = angle
    if coords != None: self.globalPos = coords
    else: self.globalPos = x,y
  
  def getDescription(self):
    return "openningdoor"

  def rotation(self,angle):
    pass
  def deplacement(self,x,y,cameraMove=None):
    self.rect.move_ip(int(x),int(y))
    vx = x / self.scale
    vy = y / self.scale
    if cameraMove == None: self.globalPos = vx + self.globalPos[0], vy + self.globalPos[1]

  def copy(self):
    pass
