# -*- coding: utf-8 -*-
# Brunie Nicolas, War Of Blood
#
# Gestionnaire d'evenement

import pygame
import math
from pygame.locals import *

class EventGestionner:
  def __init__(self,perso,camera,interface,obstacle):
    self.perso = perso
    self.camera = camera
    self.interface = interface
    self.obstacle = obstacle
    self.tmpDoubleCmd = 0
    self.totalTime = 0
    self.mousePosition = 0,0

  def getMousePosition(self):
    return self.mousePosition

  def update(self,time_between_frame):
    for event in pygame.event.get():
      if event.type == QUIT: return 0
      # mouvement de ma souris
      if event.type == MOUSEMOTION:
        px,py = event.pos
        self.mousePosition = px,py
        ox,oy = self.perso.rect.center
        d = math.sqrt((px-ox)**2+(py-oy)**2)
        if d != 0: 
          dx = float((px-ox)) / float(d)
          dy = float(py-oy) / float(d)
          self.perso.changeDirection(dx,dy)
      # bouton souris
      if event.type == MOUSEBUTTONDOWN:
        if event.button == 1: self.perso.shoot()
        elif event.button == 3: self.perso.ChangeMode()
        elif event.button == 4: self.perso.changeWeapon(+1)
        elif event.button == 5: self.perso.changeWeapon(-1)
      if event.type == MOUSEBUTTONUP:
        if event.button == 1: self.perso.unShoot()
      if event.type == KEYDOWN:
        if event.key == K_i: self.interface.saveScreen()
        elif event.key == K_p: i = raw_input("pause")
        elif event.key == K_LEFT: self.perso.setMvt("left",self.obstacle)
        elif event.key == K_r: self.perso.reload()
        elif event.key == K_c: self.perso.changeWeapon()
        elif event.key == K_SPACE: self.perso.shoot()
        elif event.key == K_RIGHT: self.perso.setMvt("right",self.obstacle)
        elif event.key == K_ESCAPE: return 0
        elif event.key == K_UP: 
          if self.totalTime - self.tmpDoubleCmd < 1000: self.perso.bigJump(self.obstacle)
          else:      self.perso.jump(self.obstacle)
          self.tmpDoubleCmd = self.totalTime
      elif event.type == KEYUP: 
        if event.key == K_SPACE: self.perso.unShoot()
        elif event.key == K_LEFT: self.perso.unsetMvt("left")
        elif event.key == K_RIGHT: self.perso.unsetMvt("right")
        elif event.key == K_q: self.camera.deplace(-10,0)
        elif event.key == K_d: self.camera.deplace(10,0)
        elif event.key == K_z: self.camera.deplace(0,10)
        elif event.key == K_s: self.camera.deplace(0,-10)
    self.totalTime += time_between_frame
    return 1
