# -*- coding: utf-8 -*-
#! /usr/env python
# Brunie nicolas, War of Blood
# gestionnaire d'affichage
from Particle import *

class GlobalSystemGestionner:
  def  __init__(self,screen,background,rate):
    self.update_rate = rate
    self.screen = screen
    self.background = background
    self.tmp_time = 0
    self.ParticleSystemList = []      # identifiant des systèmes de particules actifs
    self.ParticleSystems = {}         # système de particule actif  
    self.pid = 0                      # nouvel identifiant pour système de particule
    self.point = 0
    self.layers = {}                  # dictionnaire de liste d'elt présent dans chaque niveau d'affichage
    self.updateOrder = []             # ordre de mise à jour des layer
    self.layerCorrespondance = {}     # dictionnaire (id,layer) le ParticleSystem id se trouve dans layer
    self.camera = None
    self.perso = None

  def defineCamera(self,camera):
    self.camera = camera

  def definePerso(self,perso):
    self.perso = perso

  def defineObstacle(self,obstacle):
    self.obstacle = obstacle

  # un couple (type,description)
  # 0 pour groupe 
  # 1 pour système de particule pour matching
  # 2 pour un groupe avec draw et update(time)
  # 3 pour un groupe avec simple update
  # 4 pour un groupe avec update(time,obstacle)
  # 7 pour les personnages principal (mise à jour de la caméra)
  # 8 pour les perso avec draw, update et renderAttachement
  # 20 : sous type de 2, groupe avec draw et update(time), si update rend 0 on supprime l'item
  def attachToLayer(self,group,layer,type=0):
    """ on ajoute des groupes de sprites """
    if layer in self.layers.keys():
      self.layers[layer].append((type,group))
    else:
      self.layers[layer] = [(type,group)] 
      self.updateOrder.append(layer)
      self.updateOrder.sort()

  def getPoint(self):
    return self.point

  def addPoint(self):
    self.point += 1
    print self.point

  def attach(self,ps,layer=5):
    self.ParticleSystems[self.pid] = ps
    self.ParticleSystemList.append(self.pid)
    self.layerCorrespondance[self.pid] = layer
    ps.setId(self.pid)
    self.attachToLayer(self.pid,layer,type=1)
    id = self.pid
    self.pid += 1
    return id

  def moveParticle(self,id,x,y):
    if id in self.ParticleSystemList:
      self.ParticleSystems[id].deplacement(x,y)
      return 1
    else: return 0
    

  def remove(self,id):
    # del self.ParticleSystems[id]
    if self.isId(id) == 1: 
      self.ParticleSystemList.remove(id)
      self.layers[self.layerCorrespondance[id]].remove((1,id))

  def isId(self,id):
    if id in self.ParticleSystemList:
      return 1
    return 0

  def changeDirection(self,dx,dy):
    for i in self.ParticleSystemList:
      i.changeDirection(dx,dy)

  def changeDirection(self,id,dx,dy):
    self.ParticleSystems[id].changeDirection(dx,dy)

  def positionnement(self,id,x,y):
    self.ParticleSystems[id].positionnement(x,y)

  def update(self,time):
    """ mise à jour du gestionnaire d'affichage,
      - on met d'abord à jour la position de tous les élèments du jeu dans l'ordre
      - on repositionne la caméra pour déterminer les élèments à afficher
      - on affiche tout ses élèments dans leur ordre d'apparition """
    self.tmp_time += time
    if 1: #self.tmp_time > self.update_rate:
      for layer in self.updateOrder:
        for couple in self.layers[layer]:
          type,group = couple
          if type == 2: 
            group.update(time)
          elif type == 4:
            group.update(time,self.obstacle)
          elif type == 7:
            group.update(time,self.obstacle)
          elif type == 8:
            group.update(time,self.obstacle)
          if type == 20: 
            group.update(time)
      self.camera.center(self.perso,time)
      for layer in self.updateOrder:
        for couple in self.layers[layer]:
          type,group = couple
          if type == 0: group.draw(self.screen)
          elif type == 2: 
            group.draw(self.screen)
          elif type == 4:
            group.draw(self.screen)
          elif type == 7:
            group.draw(self.screen)
            for i in group.sprites():
              i.renderAttachement(self.screen)
          elif type == 8:
            group.draw(self.screen)
            for i in group.sprites():
              i.renderAttachement(self.screen)
          elif type == 1: 
            if not self.ParticleSystems[group].update(time):
              self.layers[layer].remove(couple)
              self.ParticleSystemList.remove(group)
              self.ParticleSystems.pop(group)
