# -*- coding: utf-8 -*-
# Brunie nicolas, War Of Blood

try:
  import sys
  import random
  import math
  import os
  import getopt
  import pygame
  from socket import *
  from pygame.locals import *
  from Common import *
  from Animation import *
except ImportError, err:
  print "Impossible de charger le module. %s" % (err)

class Perso(pygame.sprite.Sprite):
  """Une balle qui se déplace sur lécran
  Retourne: objet ball
  Fonctions: update, calcnewpos
  Attributs: area, vector"""
 
  def __init__(self):
    self.up = 400
    self.general_time = 0
    pygame.sprite.Sprite.__init__(self)
    self.image, self.rect = load_png('man30.png')
    self.animation = AnimationGestionner()
    self.animation.addAnimation("defaut",None,["man30.png","man31.png"])
    self.animation.addAnimation("better","mec_pos_00.5.png",["mec_pos_01.png","mec_pos_02.png","mec_pos_03.png","mec_pos_04.png"])
    self.animation.playAnimation("better")
    screen = pygame.display.get_surface()
    self.area = screen.get_rect()
    self.vector = 0,0 
    self.activeMvt = "none"
    self.listMvt = ["none"]
    self.a = 0
    self.inertie = 0
    self.en_lair = 0
    self.socle =  []
    self.attachement = []
    self.equipement = None
    self.life = 1000
    self.point = 0
    self.local = None
    self.surface = None
    self.attachementGroup = pygame.sprite.Group()
    self.globalpos = 0,0
    self.side = 0
    self.inversion = [] # liste des équipements dont la direction est l'opposé de celle de la vue ( ex jetpack)

  def getStringResume(self):
    return "%d %d " % self.globalpos

  def getAllDescription(self):
    liste = []
    for obe in self.attachement:
      ob = obe[0]
      liste.append(ob.getDescription())
    return liste

  def renderAttachement(self,screen):
    self.attachementGroup.draw(screen)
    return 0

  def looseLife(self,n,(x,y),pg,targets):
    self.life += n
    
  def getLife(self):
    return (self.life / 200) + 1

  def getWeapon(self):
    eq = self.equipement
    if eq != None:
      return self.attachement[eq][0].getDescription()

  def changeWeapon(self,i=+1):
    eq = self.equipement 
    self.attachement[eq][0].unshoot()
    eq = (eq + i) % len(self.attachement)
    self.equipement = eq
    ob,d1,d2,img = self.attachement[eq]
    if img != None:
      self.attachementGroup.empty()
      self.attachementGroup.add(img)

  def ChangeMode(self):
    if self.equipement != None:
      self.attachement[self.equipement][0].ChangeMode()

  def getMode(self):
    eq = self.equipement
    if eq != None:
      return self.attachement[eq][0].getMode()

  def reload(self):
    eq = self.equipement
    if eq != None:
      self.attachement[eq][0].reload()

  def changeDirection(self,dx,dy):
    inversion = 0
    if self.equipement != None:
      self.attachement[self.equipement][0].changeDirection(dx,dy)
      if self.equipement in self.inversion:
        inversion = 1
      for sp in self.attachementGroup.sprites():
        sp.rotation(dx,dy)
    if inversion:
      dx = -dx
      dy = -dy
    if dx < 0 and self.side == 0:
      self.side = 1
      self.animation.changeSide(self.side)
    elif dx > 0 and self.side == 1:
      self.side = 0
      self.animation.changeSide(self.side)

  def attach(self,ob,vdg,vdd,img=None,inversion=0):
    ob.attach(self)
    x,y = self.rect.center
    id  = len(self.attachement)
    if inversion:
      self.inversion.append(id)
    dx,dy = vdd # Vecteur Decalage Droit
    ob.positionnement(x+dx,y+dy)
    obj = None
    if img != None:
      obj = Object((x+dx,y+dy),img,id) # self.equipement)
      self.attachementGroup.empty()
      self.attachementGroup.add(obj)
      #self.attachementGroup.add(obj)
    self.attachement.append((ob,vdg,vdd,obj))
    self.equipement = id

  def shoot(self):
    eq = self.equipement
    if eq != None: self.attachement[eq][0].shoot()

  def unShoot(self):
    eq = self.equipement
    if eq != None: self.attachement[eq][0].unshoot()

  def getAttachement(self):
    tmp = [] 
    for i in self.attachement:
      ob,vdg,vdd,img = i
      tmp.append(ob.id)
    return tmp

  def removeAll(self):
    self.attachement = []

  def setMvt(self,s,obstacle):
    if not s in ["none","left","right"]:
      print "unknow mvt"
      return 0
    if s != "none":
      self.unsetMvt("none")
    if not s in self.listMvt:
      self.listMvt.append(s)

  def unsetMvt(self,s):
    if not s in ["none","left","right"]:
      print "mouvement inconnu (unsetMvt)"
      return 0
    if s in self.listMvt:
      self.listMvt.remove(s)

  def effectDirection(self,dx,dy):
    vx,vy = self.vector
    vx += dx
    vy += dy
    self.vector = vx,vy

  def getActiveMvt(self):
    # si on est dans un saut, on ne change rien
    if self.inertie == 1:
      return "none" #  self.activeMvt
    else:
      if len(self.listMvt) > 0:
        return self.listMvt[len(self.listMvt) - 1]
      else:
        return "none"

  def jump(self,obstacle):
    if self.inertie == 1: return 0
    vx,vy = self.vector
    if vy > 5 or vy <  -5: return 0
    vy -= 15
    self.vector = vx,vy
    self.inertie = 1

    
  def update(self,time,obstacle):
    # print self.life
    if self.life < 0 or self.globalpos[1] > 700:
      print "game over"
      sys.exit()
    # Mise à jour de l'animation
    self.image = self.animation.getUpdatedImage(time)
    if pygame.sprite.spritecollide(self,obstacle,0) and self.inertie == 1 and self.vector[1] > -5:
      self.inertie = 0
    newpos = self.calcnewpos(self.rect,self.vector,time,obstacle)
    self.rect = newpos
    vx = self.vector[0]
    self.activeMvt = self.getActiveMvt()
    if self.getActiveMvt() == "none" and not self.inertie:
      vx = float(vx) * 0.9
    elif self.getActiveMvt() == "left" and abs(self.vector[1]) < 5: # pygame.sprite.spritecollide(self,obstacle,0):
      if vx > -12: vx -= 0.5
    elif self.getActiveMvt() == "right" and abs(self.vector[1]) < 5: #  pygame.sprite.spritecollide(self,obstacle,0):
      if vx < 12: vx += 0.5
    else:
      vx = self.vector[0]
    vy = self.vector[1]
    self.vector = vx,vy

  def deplacement(self,dx,dy):
    self.rect.move_ip(dx,dy)
    x,y = self.rect.center
    for tob in self.attachement:
      ob,vdg,vdd,img = tob
      ob.deplacement(dx,dy)
      if img != None:
        if self.side == 0:
          dx,dy = vdd
        else:
          dx,dy = vdg
        img.positionnement(x+dx,y+dy)
    # for sp in self.attachementGroup.sprites():
    #  sp.deplacement(dx,dy)

  def updateGlobalPosition(self,dx,dy):
    gpx,gpy = self.globalpos
    self.globalpos = gpx+dx,gpy+dy
 
  def calcnewpos(self,rect,vector,time,obstacle):
    (dx,dy) = vector 
    lo = []
    for sp in obstacle.sprites():
      lo.append(sp.rect)
    self.socle = rect.move(0,dy).collidelistall(lo)
    if self.socle == []:
      dy += 0.8
      socle_y = 1000
    else:
      dy = 0
    collide_h = rect.move(dx,0).collidelistall(lo)
    for i in collide_h:
      if lo[i].top < self.rect.bottom - 2:
        dx = 0
        break
    self.vector = dx,dy
    for obp in self.attachement:
      ob,vdg,vdd,img = obp
      x,y = self.rect.center
      if self.side == 0:
        ox,oy = vdd
      elif self.side == 1:
        ox,oy = vdg
      ob.positionnement(x+ox,oy+y)
      if img != None:
        img.positionnement(x+ox,y+oy)
    self.updateGlobalPosition(dx,dy)
    return rect.move(dx,dy)
