#!/usr/bin/python
# coding: utf-8
#
# Brunie nicolas, War Of Blood
 
 
try:
  import sys
  import random
  import math
  import os
  import getopt
  import pygame
  import copy
  from socket import *
  from Common import *
  from Perso import *
  from Particle import *
  from pygame.locals import *
  from Badguy import *
  from Weapons import *
  from Environnement import *
  from Caisse import Caisse
  from CommonLevel import LevelObject
except ImportError, err:
  print "Impossible de charger le module. %s" % (err)
  sys.exit(2)
 

def min(a,b):
  if a < b: return a
  return b

def max(a,b):
  if a > b: return a
  return b

class Level:
  def __init__(self):
    self.spritGroup = pygame.sprite.Group()
    self.choiceList = [("brick",Brick),("spacedoor",SpaceDoor)]
    self.img = "block.png"
    self.choiceId = 0
    self.scale = 1
    self.center = 0,0 # point de calcul des coordonnées (initialement coin haut gauche)
    self.action1 = self.beforeInsertBlock
    self.action2 = self.insertBlock
    self.actionUpdate = self.updateLine
    self.apparition = []
    self.trigger = 0
    self.elementList = []
    #self.blockList = []

  def setElementList(self,blocklist,elist):
    self.elementList = elist
    self.blockList = blocklist

  def initialisation(self,screen,camera):
    self.screen = screen
    self.selection = Brick
    self.actState = 0
    self.lineOrigine = None
    self.localPos = None
    self.camera = camera
    camera.addStatic(self.spritGroup)

  def changeImage(self,img):
    self.img = img

  def moveCenter(self,x,y):
    cx,cy = self.center
    self.center = cx+x, cy+y

  def Zoom(self,z,camera):
    self.scale *= (2**z)
    # on met à jour chaque elt
    cx,cy = self.localPos
    for sp in self.spritGroup.sprites():
      x,y = sp.rect.center
      sp.image = pygame.transform.rotozoom(sp.image_origine,0,self.scale)
      # on fait une homothétie par rapport à la position  actuelle
      if self.localPos == None:
        print "position de la souris non initialisée"
        return 0
      gx,gy = sp.globalPos
      gx *= self.scale
      gy *= self.scale
      cx,cy = self.center
      gx += cx
      gy += cy
      sp.rect = sp.image.get_rect().move(gx,gy)
      sp.scale = self.scale
    # on met à jour l'origine
    x,y = self.center
    vx,vy = x-cx,y-cy
    vx *= self.scale
    vy *= self.scale
    self.center = cx+vx,cy+vy
    # on centre la vue de telle manière que le zoom se fasse sur le curseur

  def reinitialisation(self):
    self.spritGroup = pygame.sprite.Group()
      
  def Selection(self,i):
    self.choiceId = (self.choiceId + i) % len(self.choiceList)
    self.selection = self.choiceList[self.choiceId][1]

  def setSelection(self,s):
    self.selection = s

  def getSelectionDescription(self):
    return self.choiceList[self.choiceId][0]

# FONCTION DE GESTION DES EVENEMENTS DE LA SOURIS
  # bouton gauche enfoncé
  def act0(self,pos):
    if self.action1: self.action1(pos)

  # Mouvement de la souris
  def actE(self,pos):
    self.localPos = pos

  # bouton gauche relaché
  def act1(self,pos):
    if self.action2: self.action2(pos)

# FONCTIONS DE SELECTION DE L ACTION COURANTE
  def setDelete(self,notcare):
    self.action1 = self.beforeDeleteBlock
    self.action2 = self.afterDeleteBlock
    self.actionUpdate = None

  def setRotation(self,notcare):
    self.action1 = self.rotation
    self.action2 = None 
    self.actionUpdate = None 

  def setDeplacement(self,notcare):
    self.action1 = self.beforeDeplacement 
    self.action2 = self.afterDeplacement
    self.actionUpdate = self.updateDeplacement
    self.depList = []
    self.depPos = self.localPos

  def setInsertBlock(self,img):
    self.action1 = self.beforeInsertBlock
    self.action2 = self.insertBlock
    self.actionUpdate = self.updateLine
    self.changeImage(img)

  def setInsertElement(self,img):
    self.action1 = self.insertElement
    self.action2 = None
    self.actionUpdate = None
    self.changeImage(img)

  def setLevelObject(self,(img,type)):
    self.selection = type
    self.action1 = self.insertLevelObject
    self.action2 = None
    self.actionUpdate = None
    self.changeImage(img)

  def setCopy(self,notcare):
    self.action1 = self.beforeCopy 
    self.action2 = self.afterCopy
    self.actionUpdate = None
    self.updateDeplacement

  def setDisplayBlock(self,notcare):
    self.action1 = None 
    self.action2 = self.unTriggerDisplay
    self.actionUpdate = self.displayBlock

  def setDisplayDecor(self,notcare):
    self.action1 = None 
    self.action2 = self.unTriggerDisplayDecor
    self.actionUpdate = self.displayDecor

# FONCTIONS POUR LA SELECTION DE BLOC

  def triggerDisplay(self,pos):
    self.actionUpdate = self.displayBlock

  def unTriggerDisplay(self,pos):
    self.action2 = None
    self.actionUpdate = None
    j = self.selectionnedBlock(140,60,self.blockList)
    self.setInsertBlock(self.blockList[j])
    self.setSelection(Brick)

  def selectionnedBlock(self,h_debut,pas,liste):
    j = -1
    if self.localPos[1] <= h_debut or self.localPos == None:
      j = 0
    elif self.localPos[1] >= h_debut+pas*len(liste):
      j = len(self.elementList) - 1
    else:
      j = int (((self.localPos[1] - h_debut) / pas) )
    return j

  def displayBlock(self,time):
    self.displayList((675,140,60),self.blockList)

  def displayList(self,(origine_x,h_debut,pas),liste):
    l = []
    for ob in liste: 
      l.append(load_png(ob))
    i = 0
    # h_debut = 140
    j = -1
    if self.localPos[1] <= h_debut or self.localPos == None:
      h = h_debut
      j = 0
    elif self.localPos[1] >= h_debut+pas*len(liste):
      h = h_debut + pas * (len(liste) - 1)
      j = len(liste) - 1
    else:
      j = ((self.localPos[1] - h_debut) / pas) 
      h = ((self.localPos[1] - h_debut) / pas) * pas + h_debut
    # print h
    pygame.draw.rect(self.screen,(255,0,0),pygame.Rect(origine_x,h,110,pas))
    for ob in l:
      img,rect = ob
      # img = pygame.transform.rotate(img,90.0)
      rect = img.get_rect()
      rect.center = origine_x + 110 / 2,h_debut + 30 +i *60
      i += 1
      self.screen.blit(img,rect)


# FONCTIONS POUR LA COPIE
  def beforeCopy(self,pos):
    self.depList = []
    self.depPos = pos
    for sp in self.spritGroup:
      if sp.rect.collidepoint(pos):
        nsp = sp.copy()
        self.spritGroup.add(nsp)
        self.depList.append(nsp)
    self.actionUpdate = self.updateDeplacement

  def afterCopy(self,pos):
    self.depList = []
    self.actionUpdate = None

# FONCTIONS POUR LE DEPLACEMENT
  def beforeDeplacement(self,pos):
    """ clic gauche """
    self.depList = []
    self.depPos = pos
    for sp in self.spritGroup:
      if sp.rect.collidepoint(pos): self.depList.append(sp)
    self.actionUpdate = self.updateDeplacement

  def afterDeplacement(self,pos):
    """ relachement bouton gauche """
    self.actionUpdate = None
    self.depList = []

  def updateDeplacement(self,time):
    """ bouton gauche enfoncé """
    old = self.depPos
    self.depPos = self.localPos
    vx = self.depPos[0] - old[0]
    vy = self.depPos[1] - old[1]
    for sp in self.depList:
      sp.deplacement(vx,vy) 

# FONCTION ROTATION
  def rotation(self,pos):
    for sp in self.spritGroup.sprites():
      if sp.rect.collidepoint(pos): sp.rotation(90) # sp.image = pygame.transform.rotate(sp.image,90)

# FONCTION SUPPRESION BLOCK
  def beforeDeleteBlock(self,notcare):
    self.actionUpdate = self.deleteBlock

  def deleteBlock(self,t):
    pos = self.localPos
    for ob in self.spritGroup:
      if ob.rect.collidepoint(pos):
        self.spritGroup.remove(ob)

  def afterDeleteBlock(self,notcare):
    self.actionUpdate = None

  def beforeInsertBlock(self,pos):
    self.lineOrigine = pos
    self.actState = 1

  def insertBlock(self,pos):
    if self.actState != 1:
      return 0
    self.actState = 0
    ox,oy = self.lineOrigine
    dx,dy = pos
    lx,ly = self.localPos
    # si l'écart des abscisses est grand : ligne horizontale
    lb,hb = 100 * self.scale, 50 * self.scale# largeur et hauteur d'un bloc de base
    if abs(ox - dx) > 50:
      for i in range(int(abs(dx-ox) / lb)):
        x = min(ox,dx) + i * lb
        y = oy
        self.spritGroup.add(self.selection((x,y),None,scale=self.scale,coords=(self.getGlobalCoords(x,y)),img=self.img))
      if abs(dx - ox) > lb:
        self.spritGroup.add(self.selection((max(ox,dx) - lb,oy),None,scale=self.scale,coords=(self.getGlobalCoords(max(ox,dx) - lb,y)),img=self.img))
    # sinon blocs verticaux
    elif abs(oy -dy) > 50:
      for i in range(int(abs(dy-oy) / hb)):
        y = min(oy,dy) + i * hb
        if lx < ox:
          x = ox - lb
        else:
          x = ox
        self.spritGroup.add(self.selection((x,y),None,scale=self.scale,coords=self.getGlobalCoords(x,y),img=self.img))
      if abs(dy - oy) > hb:
        self.spritGroup.add(self.selection((x,max(oy,dy)-hb),None,scale =self.scale,coords=self.getGlobalCoords(x,max(oy,dy)-hb),img=self.img))
    else:
      x = ox
      y = oy
      sp = self.selection((x,y),None,scale=self.scale,coords=self.getGlobalCoords(x,y),img=self.img)
      self.spritGroup.add(sp)
      sp.rect.center = x,y

  def insertElement(self,pos):
    cx,cy = 0,0 # self.camera.pos
    x,y = self.getGlobalCoords(pos[0],pos[1])
    self.spritGroup.add(self.selection(None,None,(x,y,cx,cy),None)) # None,scale=self.scale,coords=self.getGlobalCoords(x,y),img=self.img))

  def insertLevelObject(self,pos):
    cx,cy = self.camera.pos
    x,y = self.getGlobalCoords(pos[0],pos[1])
    self.spritGroup.add(LevelObject((x,y),self.img,self.selection))



  def getGlobalCoords(self,x,y):
    """ donne les coordonnées réelles du point représentes par (x,y) sur l'écran, zoom .... """
    cx,cy = self.center
    dx,dy = x-cx,y-cy
    dx /= self.scale
    dy /= self.scale
    # print dx,dy
    return dx,dy


  def draw(self):
    self.spritGroup.draw(self.screen)

  # sauvegarde dans un fichier
  def saveFile(self):
    """ sauvegarde dans un fichier du level actuel """
    file = open("carte.map","w")
    file.write("# Map for War Of Blood \n")
    file.write("# Generated with LevelDesigner \n")
    file.write("# visit wobresurection.blogspot.com \n")
    for ob in self.spritGroup.sprites():
      desc = ob.getDescription()
      x,y = ob.globalPos # rect.center
      file.write("%s %d %d %s %f \n" % (desc,x,y,ob.img,ob.angle))
    file.close()

  def update(self,time):
    if self.actionUpdate: self.actionUpdate(time)

  def updateLine(self,time):
    if self.actState != 0:
      lpx,lpy = self.localPos
      ox,oy = self.lineOrigine
      if abs(ox - lpx) > 50:
        pygame.draw.line(self.screen,(0,100,0,255),(ox,oy),(lpx,oy),5)
      else:
        pygame.draw.line(self.screen,(0,100,0,255),(ox,oy),(ox,lpy),5)

  def loadFromFile(self,file):
    f = open(file,"r")
    s = f.readline()
    while s != "":
      l = s.split(" ")
      if s[0] == "#":
        s = f.readline()
        continue
      x,y = int(l[1]),int(l[2])
      img = l[3]
      angle = float(l[4])
      if l[0] == "brick":
        self.spritGroup.add(Brick((x,y),None,img=img,angle=angle))
      elif l[0] == "apparitiondoor":
        self.spritGroup.add(ApparitionDoor((x,y),None,img=img,angle=angle))
      elif l[0] == "caisse":
        cx,cy = self.camera.pos
        self.spritGroup.add(Caisse(None,None,(x,y,cx,cy),None))
      elif l[0] == "badguy":
        cx,cy = self.camera.pos
        self.spritGroup.add(LevelObject((x,y),"badguy.1.1.png","badguy"))
      s = f.readline()

  def getApparition(self):
    l = len(self.apparition)
    return self.apparition[random.randrange(0,l)]

  def createLevelFromFile(self,file,obstacle,decor,physicEngine,persoGroup,caisseGroup,others,perso,particleGestionner):
    f = open(file,"r")
    s = f.readline()
    minx,miny,maxx,maxy = 0,0,0,0
    while s != "":
      l = s.split(" ")
      if s[0] == "#":
        s = f.readline()
        continue
      x,y = int(l[1]),int(l[2])
      img = l[3]
      angle = float(l[4])
      if l[0] == "brick":
        sp = Brick((x,y),None,img=img,angle=angle)
        r = sp.rect 
        if r.left < minx: minx = r.left
        if r.top < miny: miny = r.top
        if r.bottom > maxy: maxy = r.bottom
        if r.right > maxx: maxx = r.right
        self.spritGroup.add(sp)
        obstacle.add(sp) # Brick((x,y),None,img=img,angle=angle))
      elif l[0] == "apparitiondoor":
        ad = ApparitionDoor((x,y),None,img=img,angle=angle) 
        self.spritGroup.add(ad)
        self.apparition.append(ad.rect.center)
        decor.add(ad)
      elif l[0] == "caisse":
        cx,cy = 0,0
        print "caisse %d %d " % (x,y) 
        caisse = Caisse(obstacle,persoGroup,(x,y,cx,cy),physicEngine)
        caisseGroup.add(caisse)
      elif l[0] == "badguy":
        bg = BadGuy((x,y),(x,y),obstacle,perso,physicEngine,particleGestionner)
        others.add(bg)
      s = f.readline()
    self.dimensionX = (minx,maxx)
    self.dimensionY = (miny,maxy)
    print "dimension"
    print self.dimensionX,self.dimensionY


  def getDimension(self): 
    minx,Mx = self.dimensionX
    miny,My = self.dimensionY
    return (Mx - minx,My-miny,(minx,miny))
