#!/usr/bin/python
# coding: utf-8
#
# Brunie nicolas, War Of Blood
#
 
try:
  import sys
  import random
  import math
  import os
  import getopt
  import pygame
  from socket import *
  from Common import *
  from Perso import *
  from Particle import *
  from pygame.locals import *
  from Badguy import *
  from Weapons import *
  from Environnement import *
  from Level import *
  from InterfaceLevelDesigner import *
except ImportError, err:
  print "Impossible de charger le module. %s" % (err)
  sys.exit(2)
 

class Camera:
  def __init__(self,screen,background,(longueur,largeur)):
    self.longueur = longueur
    self.largeur = largeur
    self.screen = screen
    self.background = background
    self.movable = []
    self.static = []
    self.dep = 0,0
    self.tmp_time = 0
    self.pos = 0,0

  def deplace(self,x,y):
    nx = self.dep[0] + x
    ny = self.dep[1] + y
    self.dep = nx,ny

  def update(self,time,level):
    self.tmp_time += time
    if self.tmp_time > 100:
      x,y = self.dep
      dx = x * (self.tmp_time / 20)
      dy = y * (self.tmp_time / 20)
      self.tmp_time = self.tmp_time % 100
      self.deplaceEffectif(dx,dy,level)

  def centerView(self,(x,y),level):
    s = self.screen.get_rect()
    l,h = s.width , s.height
    vx = l/2 - x
    vy = h/2 - y
    self.deplaceEffectif(vx,vy,level)


  def center(self,perso):
    px,py = perso.rect.center
    x,y = 0,0 # self.pos
    # centrage horizontal
    if px - x > self.longueur-100:
      self.deplaceEffectif(-(px-self.longueur+100),0)
    elif px - x  < 100:
      self.deplaceEffectif(100-px,0)
    # centrage vertical
    if py > y + self.largeur - 100:
      self.deplaceEffectif(0,-(py - self.largeur + 100 ))
    elif py < y + 100:
      self.deplaceEffectif(0,(y+100-py))

  def deplaceEffectif(self,x,y,level):
    level.moveCenter(x,y)
    px,py = self.pos
    self.pos = px+x,py+y
    for sgroup in self.static:
      for ssprite in sgroup.sprites():
        self.screen.blit(self.background, ssprite.rect, ssprite.rect)
        ssprite.deplacement(x,y,cameraMove=1)
    for mgroup in self.movable:
      for msprite in mgroup.sprites():
        msprite.deplacement(x,y,cameraMove=1)

  def addMouvable(self,group):
    self.movable.append(group)

  def addStatic(self,group):
    self.static.append(group)

def drawPixel(screen,x,y):
  pass
  

 
def main():
  # Initialisation de la fenêtre d'affichage
  pygame.init()
  pygame.font.init()
  longueur = 1000
  largeur = 600
  screen = pygame.display.set_mode((longueur, largeur))
  pygame.display.set_caption('Jeux ')
  Font = pygame.font.Font(os.path.join("data", "FreeMono.ttf"), 24)
  # Remplissage de l'arrière-plan
  background = pygame.Surface(screen.get_size())
  background = background.convert()
  background.fill((255,255,255))
  # Blitter le tout dans la fenêtre
  screen.blit(background, (0, 0))
  pygame.display.flip()

  # Initialisation de l'horloge
  clock = pygame.time.Clock()

  camera = Camera(screen,background,(longueur,largeur))
  # Initilialisation du gestionnaire de Level
  level = Level()
  level.initialisation(screen,camera)
  level.loadFromFile("carte.map")

  # création de l'interface
  interface = InterfaceDesigner(screen,level)
  interface.initialisation()
  boutonDroitDown = 0
  boutonPos = 0,0
  # Boucle d'évènements
  while 1:
    # S'assurer que le jeu ne fonctionne pas à plus de 60 images par secondes
    time_between_frame = clock.tick(40)
    for event in pygame.event.get():
      if event.type == QUIT:
        print "quit"
        return
      # mouvement de ma souris
      if event.type == MOUSEMOTION:
        px,py = event.pos
        level.actE((px,py))
        if boutonDroitDown: 
          ex,ey = boutonPos
          bx,by = boutonPos = event.pos
          dx,dy = bx-ex,by-ey
          camera.deplaceEffectif(dx,dy,level)
      elif event.type == MOUSEBUTTONDOWN:
        if event.button == 1:     # bouton gauche
          if not interface.actMB1(event.pos): level.act0(event.pos)
        elif event.button == 3:   # bouton droit
          boutonDroitDown = 1
          boutonPos = event.pos
          #camera.centerView(event.pos,level) 
        elif event.button == 4:   # mollette avant
          level.Zoom(+1,camera)
        elif event.button == 5:   # mollette arriere
          level.Zoom(-1,camera)
      if event.type == MOUSEBUTTONUP:
        if event.button == 1:
          level.act1(event.pos)
        elif event.button == 3:
          boutonDroitDown = 0
      elif event.type == KEYDOWN:
        # diriger la camera
        if event.key == K_LEFT:
          camera.deplace(20,0)
        elif event.key == K_RIGHT:
          camera.deplace(-20,0)
        elif event.key == K_UP:
          camera.deplace(0,20)
        elif event.key == K_DOWN:
          camera.deplace(0,-20)
        # quitter le jeu
        elif event.key == K_ESCAPE:
          if raw_input("sauvegarder les changemenst ? (Y/n)") == "Y": level.saveFile()
          return
        elif event.key == K_x:
          level.reinitialisation()
        elif event.key == K_PLUS:
          level.Zoom(+1,camera)
        elif event.key == K_MINUS:
          level.Zoom(-1,camera)
        elif event.key == K_p:
          print level.center
      elif event.type == KEYUP:
        # diriger la camera
        if event.key == K_LEFT:
          camera.deplace(-20,0)
        elif event.key == K_RIGHT:
          camera.deplace(20,0)
        elif event.key == K_UP:
          camera.deplace(0,-20)
        elif event.key == K_DOWN:
          camera.deplace(0,20)
    screen.blit(background, screen.get_rect(),screen.get_rect())#ball.rect, ball.rect)
    camera.update(time_between_frame,level)
    level.draw()
    level.update(time_between_frame)
    interface.draw()
    pygame.display.flip()
 
 
if __name__ == '__main__': 
  main()
