# -*- coding :utf-8 -*-
#! /bin/env python
#
# Brunie Nicolas, War Of Blood

from xml.dom import minidom
from Common import load_png
import pygame
from pygame.locals import *

fichier = "description.xml"
globalInteraction = {}
def rien(x):
  print "rien"

globalInteraction["normal"] = (rien,None)

class MenuGestionner:
  def __init__(self,file):
    self.doc = minidom.parse(file)
    self.cursorPosition = -100,-100
    self.Group = []
    self.background = None
    self.active = None

  def setFunction(self,name,func,arg):
    global globalInteraction
    globalInteraction[name] = (func,arg)

  def createInterface(self):
    self.Group = []
    self.interaction = []
    for ob in self.doc.getElementsByTagName("background"):
      self.background = load_png(ob.getAttribute("img"))
    for ob in self.doc.getElementsByTagName("item"):
      img = ob.getAttribute("img")
      imgOn = ob.getAttribute("imgOn")
      x = int(ob.getAttribute("x"))
      y = int(ob.getAttribute("y"))
      image,rect = load_png(img)
      image2,r = load_png(imgOn)
      rect.left,rect.top = x,y
      self.Group.append((rect,image,image2,globalInteraction[ob.getAttribute("action")]))
 
  def renderInterface(self,screen,time,eventList):
    screen.blit(self.background[0],self.background[1])
    if not self.parseEventList(eventList):
      return 0
    px,py = self.cursorPosition
    i = 0
    for ob in self.Group:
      rect = ob[0]
      if self.active == i:
        screen.blit(ob[2],rect)
      else:
        screen.blit(ob[1],rect)
      i += 1
    return 1

  def click(self,(px,py)):
    for ob in self.Group:
      rect = ob[0]
      if rect.collidepoint((px,py)):
        ob[3][0](ob[3][1])     # appel de l'interaction
        break

  def activate(self,pos):
    i = 0
    for ob in self.Group:
      rect = ob[0]
      if rect.collidepoint(pos):
        self.active = i  
        break
      i += 1

  def parseEventList(self,eventList):
    l = len(self.Group)
    for event in eventList:
      if event.type == QUIT:
        return 0
      elif event.type == MOUSEMOTION:
        self.cursorPosition = event.pos
        self.activate(event.pos)
      elif event.type == MOUSEBUTTONDOWN:
        self.click(event.pos)
      elif event.type == KEYDOWN:
        if event.key == K_UP:
          if self.active != None: self.active = (self.active - 1) % l
          else: self.active = 0
        elif event.key == K_DOWN:
          if self.active != None:
            self.active = (self.active + 1) % l
          else: self.active = 0
        elif event.key == K_RETURN:
          ob = self.Group[self.active]
          ob[3][0](ob[3][1])     # appel de l'interaction
    return 1
