# -*- coding: utf-8 -*-
#
# Brunie Nicolas, War Of Blood
# 
# Module de gestion des messages réseau

from Avatar import Avatar
from AvatarBadguy import AvatarBadGuy
import pygame
from Weapons import Rifle, ShotGun, JetPack, FireLauncher


class NetworkModule:
  def __init__(self,camera,avatarGroup,pg,pe):
    self.avatarList = {}
    self.idWaiting = []
    self.camera = camera
    self.avatarGroup = avatarGroup
    self.target = pygame.sprite.Group()
    self.particleGestionner = pg
    self.physicEngine = pe
    self.localList = {}

  def addIdWaiting(self,elt):
    self.idWaiting.append(elt)


  def parseMsg(self,msgTotal,avatarGroup):
    print msgTotal
    if msgTotal == None:
      return 0
    msg = msgTotal
    liste = msg.split(">")
    if ' ' in liste: liste.remove(' ')
    for m in liste:
      self.parseOneMsg(m+">",avatarGroup)

  def parseOneMsg(self,msgTotal,avatarGroup):
    #print msgTotal
    # message de 2 formes
    #   - "id idglobal idlocal" pour la transmission d'un identifiant
    #   - "badguy
    #   - "chg idglobal idlocal cmd"
    #         par ex "chg 1 10 new" nouvel avatar avec id 1,10
    if msgTotal == None:
      return 0
    try:
      debut = msgTotal.index("<") + 1
      fin = msgTotal.index(">")
    except:
      return 0 #raise Exception()
    msg = msgTotal[debut:fin]
    if msg != None:
      l = msg.split(' ')
      y = [l.remove('') for i in xrange(l.count(''))]
      type = l[0]
      if type == 'id':
        print "iiiid"
        elt = self.idWaiting.pop(0)
        elt.setNetworkId(int(l[1]),int(l[2]))
        self.localList[(int(l[1]),int(l[2]))] = elt
      elif type == "chg":
        gen = (l[i] for i in range(1,len(l)))
        #print gen
        idg = int(gen.next())
        idl = int(gen.next())
        if (idg,idl) in self.localList:
          try:
            while 1:
              desc = gen.next() 
              if desc == "looselife":
                d = int(gen.next())
                self.localList[(idg,idl)].looseLife(d,(None,None),None,None)
          except StopIteration:
            pass

        else:
          if not (idg,idl) in self.avatarList.keys():
            avatar = Avatar(0,0,self.camera,self.physicEngine)
            avatar.setId(idg,idl,0)
            self.avatarList[(idg,idl)] = avatar 
            self.avatarGroup.add(self.avatarList[(idg,idl)])
            rifle = Rifle(self.particleGestionner,self.target)
            shotgun = ShotGun(self.particleGestionner,self.target)
            firelauncher = FireLauncher(self.particleGestionner,self.target)
            jetpack = JetPack(self.particleGestionner,self.target)
            avatar.attach(firelauncher,(-13,0),(13,0),"Lance_Flamme.arme.png")
            avatar.attach(rifle,(-16,-10),(16,-10),"riflem16.png")
            avatar.attach(shotgun,(-18,-10),(18,-10),"fusil_a_pompe_arme.png")
            avatar.attach(jetpack,(10,0),(-10,0),"jetpack.png",inversion=1)
            print "nouveau %d %d" % (idg,idl)
          try:
            while 1:
              desc = gen.next() 
              if desc == "pos":
                x,y = int(gen.next()),int(gen.next())
                self.avatarList[(idg,idl)].positionnement(self.camera,x,y)
              elif desc == "rot":
                try:
                  dx,dy = float(gen.next()),float(gen.next())
                  self.avatarList[(idg,idl)].changeDirection(dx,dy)
                except:
                  pass
              elif desc == "weapon":
                weapon = gen.next()
                if not weapon in ["firelauncher","rifle","shotgun","jetpack"]: continue
                while self.avatarList[(idg,idl)].getWeapon()[0] != weapon:
                  print self.avatarList[(idg,idl)].getWeapon()[0]
                  self.avatarList[(idg,idl)].changeWeapon()
              elif desc == "shoot":
                self.avatarList[(idg,idl)].shoot()
              elif desc == "unshoot":
                self.avatarList[(idg,idl)].unShoot()
          except StopIteration:
            pass
      """ elif type == "badguychg":
        gen = (l[i] for i in range(1,len(l)))
        try:
          idg = int(gen.next())
          idl = int(gen.next())
        except:
          return 0
        if (idg,idl) in self.localList:
          try:
            while 1:
              desc = gen.next() 
              if desc == "looselife":
                d = int(gen.next())
                self.localList[(idg,idl)].looseLife(d,(None,None),None,None)
          except StopIteration:
            pass

        else:
          if not (idg,idl) in self.avatarList.keys():
            avatar = AvatarBadGuy(0,0,self.camera,self.physicEngine)
            avatar.setId(idg,idl,0)
            self.avatarList[(idg,idl)] = avatar 
            self.avatarGroup.add(self.avatarList[(idg,idl)])
            print "nouveau badguy %d %d" % (idg,idl)
          try:
            while 1:
              desc = gen.next() 
              if desc == "pos":
                x,y = int(gen.next()),int(gen.next())
                self.avatarList[(idg,idl)].positionnement(self.camera,x,y)
          except StopIteration:
            pass
    """
