# -*- coding: utf-8 -*-
# brunie nicolas, War Of Blood

try:
  import random
  import math
  import pygame
  from pygame.locals import *
  from Common import load_png
  from Angle import cangle
except ImportError, err:
  print "Impossible de charger le module. %s" % (err)


class SingleParticle:
  def __init__(self,x,y,r,direction,ttl,screen,color,range,back,bg,tbo=0,lethal=None,type=None):
    self.argument = {}
    self.type = type
    self.tbo = tbo
    self.back = back
    self.range = range
    self.lethal = lethal
    self.pos = x,y
    self.direction = direction
    self.life = random.randrange(ttl-100,ttl+200,20)
    self.screen = screen
    self.background = bg
    self.r = r 
    self.color = color
    if self.type == "arterialBlood":
      self.color = 160,10,10,255
    pygame.draw.circle(self.screen,self.color,(int(x),int(y)),r)
    self.tmp_time = 0
    self.update_rate = 100
    self.id = None

  def setId(self,pid):
    self.id = pid

  def update(self,time):
    self.tmp_time += time
    if self.type == "blood":
      self.direction = self.direction[0]  , (self.direction[1] + float(15) * float(time) / float(1000))
    nx,ny = self.pos
    vx,vy = self.direction
    rx1,rx2,ry1,ry2 = self.range
    self.tbo -= time
    if self.tbo < 0:
      if self.type == "blood":
        vy = vy + float(random.randrange(ry1,ry2)) / float(5)
        vx = vx + float(random.randrange(rx1,rx2)) / float(5) 
      elif self.type == "arterialBlood":
        self.direction = self.direction[0] , self.direction[1] + 0.33 
      else:
        vy = random.randrange(int(vy)+ry1,int(vy)+ry2)
        vx = random.randrange(int(vx)+rx1,int(vx)+rx2)
    nx += vx
    ny += vy
    self.pos = nx,ny
    r,g,b,a = self.color
    if g < 200 and self.type != "arterialBlood":
      rg = random.randrange(1,7)
      self.color = r,(g+rg),b,a
    tx,ty = self.pos
    pygame.draw.circle(self.screen,self.color,(int(tx),int(ty)),self.r)
    if self.back:
      pygame.draw.circle(self.background,self.color,(int(tx),int(ty)),self.r)
    self.tmp_time -= self.update_rate
    self.life -= time
    # mort de la particule
    if self.life < 0:
      return 0 
    else:
      return 1
    



class ParticleSystem:
  def __init__(self,screen,x,y,direction,rate,ttl,number,bg,range,life,back=0,tbo=0,immo=0,lethal=None,type=None):
    """ tbo : time before oscillation tps avant l'oscillation de la direction"""
    self.tbo = tbo
    self.type = type
    self.immo = immo # est ce que la source est immobile
    self.lethal = lethal
    self.back = back
    self.active = 1 
    self.particle = []
    self.range = range
    self.tmp_time = 0
    self.update_rate = 30
    self.background = bg
    self.rate = rate
    self.life = life
    self.color = (228, 0 ,0 , 255) 
    self.pos = x,y
    self.direction = direction
    self.screen = screen
    self.ttl =ttl
    self.id = None

  def setId(self,id):
    self.id = id

  def deplacement(self,dx,dy):
    nx,ny = self.pos
    nx += dx
    ny += dy
    self.pos = nx,ny

  def changeDirection(self,x,y):
    self.direction = x,y

  def positionnement(self,x,y):
    self.pos = x,y

  def update(self,time):
    if self.life != None:
      self.life -= time
      if self.life < 0: return 0 
    self.tmp_time += time
    self.tmp_time -= self.update_rate
    nx,ny = self.pos
    vx,vy = self.direction
    if not self.immo:
      nx += vx
      ny += vy
    self.pos = nx,ny
    dx,dy = vx,vy
    if self.type == "arterialBlood":
      dx = 0.3 * random.randrange(-5,6,2)
    r,g,b,a = self.color
    for i in range(self.rate):
      self.particle.append(SingleParticle(nx,ny,3,(dx,dy),self.ttl,self.screen,self.color,self.range,self.back,self.background,tbo=self.tbo,lethal=self.lethal,type=self.type))
    for p in self.particle:
      if not p.update(time): self.particle.remove(p)
    return 1


    
class ComplexParticleSystem:
  def __init__(self,screen,(x,y),timeToLive,img, scale,decreaseArg,direction=None):
    """ tbo : time before oscillation tps avant l'oscillation de la direction"""
    self.active = 1 
    self.particle = []
    self.tmp_time = 0
    self.update_rate = 30
    self.pos = x,y
    self.direction = direction
    self.screen = screen
    self.timeToLive = timeToLive
    self.totalTimeToLive = timeToLive
    self.image,self.rect = load_png(img)
    if direction == None:
      self.image = pygame.transform.rotozoom(self.image, 0.0, scale)
    else:
      dx,dy = self.direction
      self.image = pygame.transform.rotozoom(self.image, -cangle(dx,dy) , scale)
    self.image = self.image.convert_alpha()
    self.rect = self.image.get_rect()
    self.rect.center = x,y
    self.id = None
    self.decreaseArg = decreaseArg

  def setId(self,id):
    self.id = id

  def deplacement(self,dx,dy):
    nx,ny = self.pos
    nx += dx
    ny += dy
    self.pos = nx,ny
    self.rect.center = self.pos

  def changeDirection(self,x,y):
    self.direction = x,y

  def positionnement(self,x,y):
    self.pos = x,y
    self.rect.center = self.pos

  def update(self,time):
    if self.direction != None:
      dx,dy = self.direction
      f = float(time)
      self.deplacement(dx *f, dy * f)
    if self.decreaseArg > 0:
      scale = (float(self.timeToLive + self.decreaseArg ) / float(self.totalTimeToLive + self.decreaseArg))
      image = pygame.transform.rotozoom(self.image,0,scale)
      cx,cy = self.rect.center
      rect = image.get_rect()
      rect.center = cx,cy
      self.screen.blit(image,rect)
    else:
      self.screen.blit(self.image,self.rect)
    self.timeToLive -= time
    if self.timeToLive < 0: return 0
    return 1
