# -*- coding: utf-8 -*-
# Brunie nicolas, War Of Blood

try:
  import random
  import math
  import pygame
  import sys
  from pygame.locals import *
  from Common import *
  from Animation import *
  from Blast import Movable, Force
  from Angle import drawVector
  from CommonCharacter import CommonCharacter
except ImportError, err:
  print "Impossible de charger le module. %s" % (err)

invincibility = 1 # God : 1 | jonas / nicolas : 0

class GameOver(Exception):
  """ exception de game over """
  pass

class Perso(CommonCharacter):
  """Une balle qui se déplace sur lécran
  Retourne: objet ball
  Fonctions: update, calcnewpos
  Attributs: area, vector"""
 
  def __init__(self,pe):
    self.up = 400
    self.general_time = 0
    CommonCharacter.__init__(self,pe)
    self.image, self.rect = load_png('man30.png')
    self.rect.center = 0,0
    self.animation.addAnimation("defaut",None,["man30.png","man31.png"])
    self.animation.addAnimation("better","mec_pos_00.5.png",["mec_pos_01.png","mec_pos_02.png","mec_pos_03.png","mec_pos_04.png"])
    self.animation.addAnimation("idle","mec_pos_00.5.png",["mec_pos_01.png"])
    self.animation.playAnimation("better")
    self.onSocle = 0
    self.vector = 0,0 
    self.activeMvt = "none"
    self.listMvt = ["none"]
    self.inertie = 0
    # equipement 
    self.equipement = None
    self.equipementType = {}
    self.point = 0
    self.local = None
    self.surface = None
    self.side = 0
    self.inversion = [] # liste des équipements dont la direction est l'opposé de celle de la vue ( ex jetpack)
    self.destructible = None
    self.jetPack = None
    self.direction = 0,0

  def addAmunition(self,n,type):
    tmp = n 
    l = []
    for obe in self.attachement:
      if obe[0].addAmunition(0,type): l.append(obe[0])
    # on reparti equitablement les munitions + aleatoires
    for ob in l:
      ob.addAmunition(n/len(l),type)
    l[random.randrange(0,len(l))].addAmunition(n % len(l),type)

  def deplaceAttachement(self,dx,dy):
    """ on redéfini deplaceAttachement pour correspondre  aux
      spécificités de Perso """
    x,y = self.rect.center
    for obp in self.attachement:
      ob,vdg,vdd,img = obp
      if self.side == 0:
        ox,oy = vdd
      elif self.side == 1:
        ox,oy = vdg
      ob.positionnement(x+ox,oy+y)
      if img != None:
        img.positionnement(x+ox,y+oy)

  def setOnSocle(self):
    self.onSocle = 1

  def addDestructible(self,destructible):
    self.destructible = destructible

  def setNetworkId(self,idg,idl):
    print "perso new id %d %d " % (idg,idl)
    self.networkId = idg,idl

  def getStringResume(self):
    if self.networkId == None:
      return ""
    gx,gy = self.globalpos
    dx,dy = self.direction
    idg,idl = self.networkId
    return "chg %d %d  pos %d %d rot %f %f" % (idg,idl,gx,gy,dx,dy) 

  def getAllDescription(self):
    liste = []
    for obe in self.attachement:
      ob = obe[0]
      liste.append(ob.getDescription())
    return liste

  def renderAttachement(self,screen):
    self.attachementGroup.draw(screen)
    return 0

  def min(a,b):
    if a < b : return a
    return b

  def addLife(self,n):
    initialLife = 1000
    self.life = min(self.life + n,initialLife)
    

  def getSurfaceLife(self):
    life = int(self.getLife())
    # on ne crée une nouvelle surface que si la valeur de vie a été modifié depuis le dernier
    # appel de cette fonction
    if self.local == None or life != self.local:
      tmp = pygame.Surface((45*6,68))
      tmp.convert()
      tmp.fill((255,255,255))
      ecart = 45 * (6 - life) / 2
      group = pygame.sprite.Group()
      for i in range(life):
        x = i*45+ecart
        logo = Picture((x,0),"heartlogo.png")
        group.add(logo)
      group.draw(tmp)
      self.surface = tmp
    return self.surface

  def getSurfaceLife2(self,screen,dx,dy):
    life = self.life
    if self.local == None or life != self.local:
      group = pygame.sprite.Group()
      if life >= 200:
        val = 200
      else: val = life
      life -= val
      x = 0
      while val > 0:
        logo = Picture((dx+x,dy),"heartlogo.png",scale=(float(val)/200.0))
        group.add(logo)
        x += 45
        if life >= 200:
          val = 200
        else: val = life
        life -= val
      self.surface = group
    self.surface.draw(screen)
      
  def getAmuLevel(self):
    eq = self.equipement
    if eq != None:
      return self.attachement[eq][0].bullet
    return 0

  def getLoadLevel(self):
    """ obtenir le niveau de munition de l'arme courante sous forme d'une barre de chargement ( Surface ) """
    eq = self.equipement
    if eq != None:
      level = 194 * self.attachement[eq][0].getLoadLevel()
    else: level = 100
    surface = pygame.Surface((200,50))
    surface.convert()
    surface.fill((255,255,255))
    pygame.draw.rect(surface,(0,0,0),Rect(0,0,200,50),3)
    pygame.draw.rect(surface,(0,0,150),Rect(3,3,level,44))
    return surface 

  def getWeapon(self):
    eq = self.equipement
    if eq != None:
      return self.attachement[eq][0].getDescription()

  def changeWeapon(self,i=+1):
    eq = self.equipement 
    self.attachement[eq][0].unshoot()
    eq = (eq + i) % len(self.attachement)
    self.equipement = eq
    ob,d1,d2,img = self.attachement[eq]
    if img != None:
      self.attachementGroup.empty()
      self.attachementGroup.add(img)
    self.listResume.append("weapon %s" % (ob.getDescription())[0])

  def ChangeMode(self):
    if self.equipement != None:
      self.attachement[self.equipement][0].ChangeMode()

  def getMode(self):
    eq = self.equipement
    if eq != None:
      return self.attachement[eq][0].getMode()

  def reload(self):
    eq = self.equipement
    if eq != None:
      self.attachement[eq][0].reload()

  def changeDirection(self,dx,dy):
    self.direction = dx,dy
    inversion = 0
    if self.equipement != None:
      self.attachement[self.equipement][0].changeDirection(dx,dy)
      if self.equipement in self.inversion:
        inversion = 1
      for sp in self.attachementGroup.sprites():
        sp.rotation(dx,dy)
    if inversion:
      dx = -dx
      dy = -dy
    if dx < 0 and self.side == 0:
      self.side = 1
      self.animation.changeSide(self.side)
    elif dx > 0 and self.side == 1:
      self.side = 0
      self.animation.changeSide(self.side)
    self.listResume.append("rot %f %f" % (dx,dy))

  def attach(self,ob,vdg,vdd,object=None,inversion=0):
    if ob.type in self.equipementType.keys():
      pass
      return 0
    self.equipementType[ob.type] = ob
    ob.attach(self)
    x,y = self.rect.center
    id  = len(self.attachement)
    if inversion:
      self.inversion.append(id)
    dx,dy = vdd # Vecteur Decalage Droit
    ob.positionnement(x+dx,y+dy)
    obj = None
    if object != None:
      obj = object #Object((x+dx,y+dy),img,id) # self.equipement)
      obj.setId(id)
      obj.positionnement(x+dx,y+dy)
      self.attachementGroup.empty()
      self.attachementGroup.add(obj)
    self.attachement.append((ob,vdg,vdd,obj))
    self.equipement = id

  def shoot(self):
    eq = self.equipement
    if eq != None: self.attachement[eq][0].shoot()
    self.listResume.append("shoot")
    #x,y = self.rect.center

  def unShoot(self):
    eq = self.equipement
    if eq != None: self.attachement[eq][0].unshoot()
    self.listResume.append("unshoot")

  def getAttachement(self):
    tmp = [] 
    for i in self.attachement:
      ob,vdg,vdd,img = i
      tmp.append(ob.id)
    return tmp

  def removeAll(self):
    self.attachement = []

  def setMvt(self,s,obstacle):
    if not s in ["none","left","right"]:
      print "unknow mvt"
      return 0
    if s != "none":
      self.unsetMvt("none")
    if not s in self.listMvt:
      self.listMvt.append(s)

  def unsetMvt(self,s):
    if not s in ["none","left","right"]:
      print "mouvement inconnu (unsetMvt)"
      return 0
    if s in self.listMvt:
      self.listMvt.remove(s)

  def effectDirection(self,dx,dy):
    vx,vy = self.vector
    vx += dx
    vy += dy
    self.vector = vx,vy

  def getActiveMvt(self,d):
    # si on est dans un saut, on ne change rien
    if d > 5: return "none"
    else:
      if len(self.listMvt) > 0: return self.listMvt[len(self.listMvt) - 1]
      else: return "none"

  def jump(self,obstacle):
    if self.physicEngine.getGroundDistance(self,self.rect) < 5:# and vy > -5: 
      self.forces[2].append(Force("jump",0,-300,self.physicEngine))
      self.inertie = 1

  def bigJump(self,obstacle):
    """ si le bouton saut est pressé 2 fois rapidement on met en marche le jetpack"""
    if self.jetPack != None:
      dx,dy = self.vector
      if dx == 0 and dy == 0:
        return 0
      self.jetPack.changeDirection(-dx,-dy)
      self.jetPack.shoot(time=200)

  def update(self,time,obstacle):
    if self.life < 0 and not invincibility: # or self.globalpos[1] > 700: , distance de chute
      self.die()
      print "game over"
      raise GameOver()
      #raise raw_input("vous etes mort")
    # Mise à jour de l'animation
    vx = self.vector[0]
    if abs(vx) > 1:
      self.animation.playAnimation("better")
    else:
      self.animation.playAnimation("idle")
    self.image = self.animation.getUpdatedImage(time,vitesse=2.2)
    # ax,ay = self.physicEngine.accelerationCalculus(self,time)
    d = self.physicEngine.getGroundDistance(self,self.rect)
    self.activeMvt = self.getActiveMvt(d)
    max_vx = 12
    if self.getActiveMvt(d) == "none" and d < 5: #not self.inertie:
      vx = float(vx) * 0.9
      # print self.getActiveMvt(d)
      if abs(vx) < 0.01: vx = 0
    elif self.getActiveMvt(d) == "left" and d < 5:#abs(self.vector[1]) < 5: # pygame.sprite.spritecollide(self,obstacle,0):
      if vx > -max_vx: vx -= 0.5
    elif self.getActiveMvt(d) == "right" and d < 5: #abs(self.vector[1]) < 5: #  pygame.sprite.spritecollide(self,obstacle,0):
      if vx < max_vx: vx += 0.5
    else:
      vx = self.vector[0]
    vy = self.vector[1]
    # if d > 2: vy += 1
    ax,ay =  self.physicEngine.accelerationCalculus(self,time)
    #drawVector(self.screen,ax,ay,self.rect.center)
    # print ax,ay
    self.vector = vx +  ax,vy + ay
    self.calcnewpos(self.rect,self.vector,time,obstacle)
    self.listResume.append("pos %d %d" % self.globalpos)

 
  def calcnewpos(self,rect,vector,time,obstacle,update=1):
    (dx,dy) = vector 
    ndx,ndy = self.physicEngine.mouvement(self,dx,dy,caisse=1)
    if update: self.vector = ndx,ndy
    idx,idy = int(ndx),int(ndy)
    self.rect.move_ip(idx,idy)
    for obp in self.attachement:
      ob,vdg,vdd,img = obp
      x,y = self.rect.center
      if self.side == 0:
        ox,oy = vdd
      elif self.side == 1:
        ox,oy = vdg
      ob.positionnement(x+ox,oy+y)
      if img != None:
        img.positionnement(x+ox,y+oy)
    self.updateGlobalPosition(idx,idy)
    return idx,idy

    
  def forcedMove(self,dx,dy,obstacle):
    self.calcnewpos(self.rect,(dx,dy),20,obstacle,update=1)

