# -*- coding: utf-8 -*-
# Brunie Nicolas, War Of Blood

try:
  import random
  import math
  import pygame
  from Common import *
  from Angle import drawLoadedImageLine,cangle
  from Particle import *
  from pygame.locals import *
  from ClassWeapon import Weapon
  from Animation import AnimationOnScreen
  from Blast import Force
  from Amunition import Bullet
except ImportError, err:
  print "Impossible de charger le module. %s" % (err)
  sys.exit(2)

def pint(pos):
  x,y = pos
  return int(x),int(y)

class Explosion:
  def __init__(self,(x,y),arg):
    self.number = arg["number"]
    self.pos = x,y
    self.particleGestionner = arg["pg"]
    self.launch()    
    
  def launch(self):
    for i in range(10*self.number):
      dx = random.randrange(-10,10)
      dy = random.randrange(-10,10)
      screen = self.particleGestionner.screen
      x,y = pint(self.pos)
      rate = 1
      ttl = 30
      rrange = (-1,2,-1,2)
      life = 400
      number = 10
      ps = ParticleSystem(screen,x,y,(dx,dy),rate,ttl,number,self.particleGestionner.background,rrange,life,back=0)
      self.particleGestionner.attach(ps)

class Explosion2:      
  def __init__(self,(x,y),arg):
    self.pos = x,y
    self.particleGestionner = arg["pg"]
    self.screen = self.particleGestionner.screen
    self.animation = AnimationOnScreen(self.screen,None,[
    "explosion.02.png",
    "explosion.03.png",
    "explosion.04.png",
    "explosion.05.png",
    "explosion.06.png"]) #,
    #"explosion.07.png",
    #"explosion.08.png",
    #"explosion.09.png"
    #])
    self.animation.positionnement(x,y)
    self.launch()    
    self.id = None
    self.active = 1
  
  def setId(self,id):
    self.id = id
    
  def launch(self):
    self.particleGestionner.attach(self) #AllFrame(self) # on ajoute un evt qui doit etre mis à jour à chaque frame

  def update(self,time):
    return self.animation.renderUpdatedFrame(time)

def vectdist(va,vb):
  return math.sqrt((va[0]-vb[0])**2+(va[1]-vb[1])**2)

class Grenade:
  def __init__(self,arg):
    self.pos  = arg["pos"]
    self.direction = arg["direction"]
    self.timeBeforeExplosion = arg["tbe"]
    self.particleGestionner = arg["pg"]
    self.obstacle = arg["obstacle"]
    self.target = arg["target"]
    self.destructible = arg["destructible"]
    self.id = None
    self.active = 1
    self.image,self.rect = load_png("grenade.png")
    self.imageOrigine,a = load_png("grenade.png")
    self.rect.center = self.pos
    self.angle = 0

  def setId(self,id):
    self.id = id

  def update(self,time):
    self.angle += float(time) / 1000.0 * 100 
    self.angle %= 360
    self.timeBeforeExplosion -= time
    if self.timeBeforeExplosion < 0:
      self.explode()
      return 0
    dx,dy = self.direction
    dy += float(5) * float(time) / float(1000) 
    px,py = self.pos
    for ob in self.obstacle.sprites():
      if ob.rect.collidepoint((px+dx,py)):
        dx = -dx
        break
    for ob in self.obstacle.sprites():
      if ob.rect.collidepoint((px+dx,py+dy)):
        dy = -dy
        break
    self.direction = dx,dy 
    self.pos = px+dx , py+dy
    self.image = pygame.transform.rotate(self.imageOrigine,self.angle)
    self.rect = self.image.get_rect()
    self.rect.center = self.pos
    self.particleGestionner.screen.blit(self.image,self.rect)
    #pygame.draw.circle(self.particleGestionner.screen,(100,0,0,255),pint(self.pos),4)
    return 1

  def explode(self):
    arg = {}
    arg["number"] = 10
    arg["pg"] = self.particleGestionner
    e = Explosion2(self.pos,arg)
    for target in self.target:
      if vectdist(target.rect.center,self.pos) < 100:
        target.looseLife(-10000,self.pos,self.particleGestionner,self.target) 
    for des in self.destructible.sprites():
      #print "go"
      if vectdist(des.rect.center,self.pos) < 100:
        des.takeDamage(-100)
      

class Rifle(Weapon):
  def __init__(self,pg,target):
    Weapon.__init__(self,pg,target,"rifle",0,"bullet")
    self.perso = None
    self.particleGestionner = pg
    self.target = target
    self.direction = 0,0
    self.bullet = 90
    self.mode = 0
    self.stay = 3
    self.id = None
    self.active = 1 # toujours actif
    self.icone,_ = load_png("icone.m16.2.png")
    self.pos = 0,0

  def getLoadLevel(self):
    return float(self.bullet) / 90.0

  def ChangeMode(self):
    self.mode = 1 - self.mode

  def getDescription(self):
    return "rifle",self.icone # "rifle"

  def setId(self,id):
    self.id = id

  def getMode(self):
    if self.mode == 0:
      return "normal"
    elif self.mode == 1:
      return "rafale"

  def changeDirection(self,dx,dy):
    dx = float(dx)
    dy = float(dy)
    a = float(150) / math.sqrt(dx*dx+dy*dy) 
    self.direction = (a*dx),(a*dy)

  def attach(self,perso):
    self.perso = perso

  def shoot(self):
    if self.mode:
      self.stay = 3
      self.particleGestionner.attach(self)
    self.OneShoot()
    particle = ComplexParticleSystem(self.particleGestionner.screen,self.pos,100,"rifleShoot.png",1,0,direction=self.direction)   # 500 argument de décroissance
    self.particleGestionner.attach(particle)


  def OneShoot(self):
    vx,vy = self.direction
    if abs(vx) < 1 and abs(vy) < 1:
      return 0
    if self.bullet <= 0:
      return 0
    self.bullet -= 1
    b = Bullet(10,self.direction,self.pos,self.particleGestionner,self.target)  # self.pos au lieu de self.perso.rect.center
    self.particleGestionner.attach(b)

  def unshoot(self):
    pass

  def update(self,t):
    if self.stay <= 0: return 0
    else:
      self.stay -= 1
      self.OneShoot()
      return 1

  def positionnement(self,x,y):
    self.pos = x,y

  def deplacement(self,dx,dy):
    x,y = self.pos
    self.pos = dx + x , dy + y




class FireLauncher(Weapon):
  def __init__(self,pg,target):
    Weapon.__init__(self,pg,target,"firelauncher",0,"fuel")
    self.perso = None
    self.particleGestionner = pg
    self.target = target
    self.direction = 0,0
    self.bullet = 90
    self.id = None
    self.active = 1 # toujours actif
    self.pid = None
    self.mid = None
    self.tmp_time = 0
    self.icone,a = load_png("lance_flamme.png")

  def getLoadLevel(self):
    return 1

  def ChangeMode(self):
    pass

  def getDescription(self):
    return "firelauncher",self.icone

  def setId(self,id):
    self.id = id

  def getMode(self):
    return "normal"

  def changeDirection(self,dx,dy):
    dx = float(dx)
    dy = float(dy)
    a = float(7) / math.sqrt(dx*dx+dy*dy) 
    self.direction = (a*dx),(a*dy)
    if self.pid != None:
      ax,ay = self.direction
      self.particleGestionner.changeDirection(self.pid,ax,ay)

  def attach(self,perso):
    self.perso = perso

  def shoot(self):
    x,y = self.perso.rect.center
    rate = 30
    ttl = 800
    number = 150
    bg = self.particleGestionner.background
    range = -3,4,-2,3
    life = None # correspond a infini
    dx,dy = self.direction
    # print self.direction
    ps = ParticleSystem(self.particleGestionner.screen,x,y,(dx,dy),rate,ttl,number,bg,range,life,back=0,tbo=70,immo=1,lethal=self.target)
    #  ps = ParticleSystem(screen,x,y,direction,rate,ttl,number,self.particleGestionner.background,range,life,back=1)
    self.pid = self.particleGestionner.attach(ps)
    self.mid = self.particleGestionner.attach(self)

  def lethalShoot(self):
    vx, vy = self.direction
    vx *= float(4)
    vy *= float(4)
    b = Bullet(3.5,(vx,vy),self.perso.rect.center,self.particleGestionner,self.target,invisibility=1)
    self.particleGestionner.attach(b)

  def unshoot(self):
    if self.pid != None:
      self.particleGestionner.remove(self.pid)
      self.particleGestionner.remove(self.mid)
      self.pid = None

  def update(self,time):
    self.tmp_time += time
    if self.tmp_time > 100: # taux de rafraichissement
      self.tmp_time = 0
      self.lethalShoot()
    return 1

  def positionnement(self,x,y):
    if self.pid != None:
      self.particleGestionner.positionnement(self.pid,x,y)

  def deplacement(self,dx,dy):
    pass

def min(a,b):
  if a < b: return a
  return b

class ShotGun(Weapon):
  def __init__(self,pg,target):
    Weapon.__init__(self,pg,target,"shotgun",0,"bullet")
    self.perso = None
    self.particleGestionner = pg
    self.target = target
    self.direction = 0,0
    self.bullet = 90
    self.mode = 0
    self.stay = 3
    self.id = None
    self.active = 1 # toujours actif
    self.icone,a = load_png("shootgun.png")

  def getLoadLevel(self):
    return float(self.bullet) / 90.0

  def ChangeMode(self):
    return 0 #self.mode = 1 - self.mode

  def getDescription(self):
    return "shotgun",self.icone

  def setId(self,id):
    self.id = id

  def getMode(self):
    return "normal"
    if self.mode == 0:
      return "normal"
    elif self.mode == 1:
      return "rafale"

  def changeDirection(self,dx,dy):
    dx = float(dx)
    dy = float(dy)
    a = float(80) / math.sqrt(dx*dx+dy*dy) 
    self.direction = (a*dx),(a*dy)

  def attach(self,perso):
    self.perso = perso

  def shoot(self):
    if self.mode:
      self.stay = 3
      self.particleGestionner.attach(self)
    self.OneShoot()

  def OneShoot(self):
    vx,vy = self.direction
    if abs(vx) < 1 and abs(vy) < 1:
      return 0
    if self.bullet <= 0:
      return 0
    nb_bullets = min(random.randrange(6,10),self.bullet)
    self.bullet -= nb_bullets
    for i in range(nb_bullets):
      tdx,tdy= self.direction
      norme = math.sqrt(tdx * tdx + tdy * tdy)
      # variation de la norme 
      # variation orthogonale à la direction
      nr = random.randrange(10,60)
      orthr = random.randrange(-20,21) / 60.0
      orthx,orthy = tdy * orthr, -tdx * orthr
      # print norme
      tdx /= norme
      tdy /= norme
      tdx *= (norme + nr)
      tdy *= (norme + nr)
      tdx += orthx
      tdy += orthy
      b = Bullet(10,(tdx,tdy),self.perso.rect.center,self.particleGestionner,self.target,img="balle.png",life=300)
      self.particleGestionner.attach(b)

  def unshoot(self):
    pass

  def update(self,t):
    if self.stay <= 0: return 0
    else:
      self.stay -= 1
      self.OneShoot()
      return 1

  def positionnement(self,x,y):
    pass

  def deplacement(self,dx,dy):
    pass

class JetPack(Weapon):
  def __init__(self,pg,target):
    Weapon.__init__(self,pg,target,"jetpack",0,"fuel")
    self.perso = None
    self.particleGestionner = pg
    self.direction = 0,0
    self.id = None
    self.active = 1 # toujours actif
    self.pid = None
    self.mid = None
    self.bullet = 1
    self.shooted = 0
    self.mode = "normal"
    self.y_target = None
    self.real_y_target = None
    self.fuel = 100
    self.state = "normal"
    self.icone,a = load_png("jetpack_logo2.png")
    self.time = None

  def getLoadLevel(self):
    return float(self.fuel) / 100.0

  def ChangeMode(self):
    if self.mode == "normal":
      self.mode = "equilibre"
      self.y_target = self.perso.rect.center[1]
      self.real_y_target = self.y_target
    else:
      self.mode = "normal"
      self.unshoot()

  def getDescription(self):
    return "jetpack",self.icone

  def setId(self,id):
    self.id = id

  def getMode(self):
    return self.mode

  def changeDirection(self,dx,dy):
    dx = float(dx)
    dy = float(dy)
    if dx == 0 and dy == 0:
      self.direction = 0,0
    else:
      a = float(7) / math.sqrt(dx*dx+dy*dy) 
      self.direction = (a*dx),(a*dy)
    if self.pid != None:
      ax,ay = self.direction
      self.particleGestionner.changeDirection(self.pid,ax,ay)

  def attach(self,perso):
    self.perso = perso
    self.perso.jetPack = self

  def shoot(self,time=None):
    self.shooted = 1
    self.time = time

  def fire(self):
    x,y = self.perso.rect.center
    rate = 30
    ttl = 800
    number = 150
    bg = self.particleGestionner.background
    range = -3,4,-2,3
    life = None # correspond a infini
    dx,dy = self.direction
    # print self.direction
    ps = ParticleSystem(self.particleGestionner.screen,x,y,(dx,dy),rate,ttl,number,bg,range,life,back=0,tbo=70,immo=1,lethal=None)
    self.pid = self.particleGestionner.attach(ps)
    self.mid = self.particleGestionner.attach(self)

  def unshoot(self):
    self.shooted = 0
    if self.pid != None:
      self.particleGestionner.remove(self.pid)
      self.particleGestionner.remove(self.mid)
      self.pid = None

  def reload(self):
    self.state = "reload"
    self.unshoot()

  def update(self,time):
    if self.time != None:
      self.time -= time
      if self.time < 0:
        self.unshoot()
    if self.perso != None and (self.shooted or self.mode == "equilibre") and self.state == "normal":
      if self.pid == None: self.fire()
      dx,dy = self.direction
      vx = - float(dx) * float(time) / float(100) 
      vy = - float(dy) * float(time) / float(100) 
      if self.mode == "equilibre":
        vx /= float(3) 
        if self.perso.rect.center[1] > self.y_target + 10:
          vy = - 3 * float(time) / float(100)
        else:
          vy = 0
      self.perso.effectDirection(vx,vy)
      if self.y_target != None: 
        if abs(self.y_target - self.real_y_target) < 10: self.y_target += 0.22 * random.randrange(-5,5)
        else: self.y_target = (self.y_target + self.real_y_target) / 2
      self.fuel -= float(time) / 10.0 
      if self.fuel < 0:
        self.unshoot()
        self.state = "reload" # état de recharge
    elif self.state == "reload":
      self.fuel += float(time) / 100.0 
      if self.fuel > 100.0:
        self.fuel = 100
        self.state = "normal"
    return 1

  def positionnement(self,x,y):
    if self.pid != None:
      self.particleGestionner.positionnement(self.pid,x,y)

  def deplacement(self,dx,dy):
    pass


class GrenadeLauncher(Weapon):
  def __init__(self,pg,target,obstacle,destructible):
    Weapon.__init__(self,pg,target,"grenadelauncher",0,"grenade")
    self.obstacle = obstacle
    self.perso = None
    self.particleGestionner = pg
    self.target = target
    self.direction = 0,0
    self.bullet = 90
    self.mode = 0
    self.stay = 3
    self.id = None
    self.active = 1 # toujours actif
    self.loadTime = 0
    self.state = 0
    self.icone,a = load_png("lance_grenade.png")
    self.pos = 0,0
    self.destructible = destructible

  def getLoadLevel(self):
    return float(self.loadTime) / 1000.0

  def ChangeMode(self):
    pass

  def getDescription(self):
    return "grenadelauncher",self.icone

  def setId(self,id):
    self.id = id

  def getMode(self):
    return "normal"

  def changeDirection(self,dx,dy):
    dx = float(dx)
    dy = float(dy)
    a = float(16) / math.sqrt(dx*dx+dy*dy) 
    self.direction = (a*dx),(a*dy)

  def attach(self,perso):
    self.perso = perso

  def shoot(self):
    self.state = 1

  def grenadelaunch(self,strength):
    arg = {}
    arg["pos"] = self.pos
    dx,dy = self.direction
    arg["direction"] = float(strength) * dx, float(strength) * dy
    arg["tbe"] = 1000
    arg["pg"] = self.particleGestionner
    arg["obstacle"] = self.obstacle
    arg["target"] = self.target
    arg["destructible"] = self.destructible
    self.bullet -= 1
    grenade = Grenade(arg)
    self.particleGestionner.attach(grenade)

  def unshoot(self):
    self.state = 0

  def update(self,t):
    if self.state == 1:
      self.loadTime += t
      if self.loadTime > 1000:
        self.loadTime = 1000
        # self.state = 0
    if self.state != 1 and self.loadTime > 0:
      self.grenadelaunch(float(self.loadTime) / 1000.0)
      self.loadTime = 0

  def positionnement(self,x,y):
    self.pos = x,y

  def deplacement(self,dx,dy):
    x,y = self.pos
    self.pos = x + dx, y + dy

class Rocket:
  def __init__(self,vitesse,chemin,pos,pg,target,targetGroup,camera,direction):
    self.particleGestionner = pg
    self.vitesse = vitesse
    self.direction = direction # direction initiale
    self.pos = pos
    self.screen = pg.screen
    self.id = None
    self.active = 1
    self.targetRect = target.rect
    self.targetGroup = targetGroup
    self.chemin = chemin
    self.chemin.reverse()
    self.camera = camera
    self.imageOrigine,r = load_png("rocket.png")
    if len(self.chemin) < 2: self.next = None
    else: 
      chemin.pop(0)
      self.next = chemin.pop(0)

  def setId(self,id):
    self.id = id

  def explode(self):
    arg = {}
    arg["number"] = 10
    arg["pg"] = self.particleGestionner
    e = Explosion2(self.pos,arg)
    for target in self.targetGroup:
      if vectdist(target.rect.center,self.pos) < 100:
        target.looseLife(-10000,self.pos,self.particleGestionner,self.targetGroup) 

  def update(self,time):
    camx,camy = self.camera.pos
    #print self.pos
    tx,ty = self.targetRect.center
    px,py = self.pos
    d = math.sqrt((tx-px)**2+(ty-py)**2)
    if d < 50 or len(self.chemin) == 0:
      self.explode()
      return 0
    else:
      cx,cy = self.next
      cx -= camx
      cy -= camy
      d = math.sqrt((cx-px)**2+(cy-py)**2)
      if d < 20:
        self.next = self.chemin.pop(0)
      cx,cy = self.next
      cx -= camx
      cy -= camy
      # direction
      dx = cx - px
      dy = cy - py
      d = math.sqrt((cx-px)**2+(cy-py)**2)
      dx = self.vitesse * dx / d 
      dy = self.vitesse * dy / d 
      # le vecteur varie peu à peu vers la direction visée
      varx = (dx + 9 * self.direction[0]) / 10
      vary = (dy + 9 * self.direction[1]) / 10
      self.direction = varx,vary
      self.pos = px + varx / time,py + vary / time
      ax,ay = self.pos # coordonnées d'affichage
      # pygame.draw.circle(self.screen,(100,100,100),(int(ax),int(ay)),4)
      image = pygame.transform.rotate(self.imageOrigine,-cangle(varx,vary))
      rect = image.get_rect()
      rect.center = self.pos
      self.screen.blit(image,rect)
      return 1
    


class RocketLauncher(Weapon):
  def __init__(self,pg,target,obstacle,pathModule,camera,eventGestionner):
    Weapon.__init__(self,pg,target,"rocketlauncher",0,"rocket")
    self.obstacle = obstacle
    self.perso = None
    self.particleGestionner = pg
    self.direction = 0,0
    self.bullet = 90
    self.mode = 0
    self.stay = 3
    self.id = None
    self.active = 1 # toujours actif
    self.loadTime = 0
    self.state = 0
    self.icone,a = load_png("lance_grenade.png")
    self.pos = 0,0
    # module tête chercheuse
    self.camera = camera
    self.pathModule = pathModule
    self.pathId = None
    self.path = []
    self.targetGroup = target
    self.target = None
    self.eventGestionner = eventGestionner

  def getLoadLevel(self):
    return float(self.loadTime) / 1000.0

  def ChangeMode(self):
    px,py = self.eventGestionner.getMousePosition() 
    for sp in self.targetGroup.sprites():
      if sp.rect.collidepoint(px,py):
        self.target = sp
        #print sp
        return 0
    self.target = None


  def getDescription(self):
    return "rocketLauncher",self.icone

  def setId(self,id):
    self.id = id

  def getMode(self):
    return "normal"

  def changeDirection(self,dx,dy):
    dx = float(dx)
    dy = float(dy)
    a = float(400) / math.sqrt(dx*dx+dy*dy) 
    self.direction = (a*dx),(a*dy)

  def attach(self,perso):
    self.perso = perso

  def shoot(self):
    if self.target == None: return 0
    cx,cy = self.camera.pos
    px,py = self.pos
    tx,ty = self.target.rect.center
    self.state = 1
    self.pathId = self.pathModule.askPath(px+cx,py+cy,tx+cx,ty+cy)
    self.particleGestionner.attach(self)

  def rocketLaunch(self,chemin):
    rocket = Rocket(200,chemin,self.pos,self.particleGestionner,self.target,self.targetGroup,self.camera,self.direction) 
    self.particleGestionner.attach(rocket)

  def unshoot(self):
    self.state = 0

  def update(self,t):
    id = self.pathModule.getPath(self.pathId)
    if id == None:
      return 1
    else:
      self.rocketLaunch(id)
      return 0

  def positionnement(self,x,y):
    self.pos = x,y

  def deplacement(self,dx,dy):
    x,y = self.pos
    self.pos = x + dx, y + dy



class Levitation(Weapon):
  def __init__(self,pg,movable,eventGestionner,pe):
    Weapon.__init__(self,pg,None,"levitation",0,"mana")
    self.particleGestionner = pg
    self.direction = 0,0
    self.eventGestionner = eventGestionner
    self.movable = movable
    self.position = 0,0
    self.physicEngine = pe
    self.icone,a = load_png("levitation.png")
    self.particleGestionner.attach(self)
    self.listeMouvement = []
    self.object = Object((0,0),"levitation2.png",0)
    self.objectGroup = pygame.sprite.Group(self.object)

  def getLoadLevel(self):
    return 1 #float(self.loadTime) / 1000.0

  def ChangeMode(self):
    px,py = self.position
    for sp in self.movable.sprites():
      if sp.rect.collidepoint(px,py): 
        sp.rebuild()

  def getDescription(self):
    return "rocketLauncher",self.icone

  def setId(self,id):
    self.id = id

  def getMode(self):
    return "normal"

  def changeDirection(self,dx,dy):
    dx = float(dx)
    dy = float(dy)
    a = float(20) / math.sqrt(dx*dx+dy*dy) 
    self.direction = (a*dx),(a*dy)

  def attach(self,perso):
    self.perso = perso

  def shoot(self):
    px,py = self.position
    # print px,py
    for sp in self.movable.sprites():
      if sp.rect.collidepoint(px,py): 
        # print "shoot"
        #sp.sustentation()
        self.listeMouvement.append(sp)


  def unshoot(self):
    #for sp in self.listeMouvement:
    #  sp.unSustentation()
    for sp in self.listeMouvement:
      sp.direction = self.direction
    self.listeMouvement = []

  def update(self,t):
    ox,oy = self.position
    self.position = self.eventGestionner.getMousePosition()
    px,py = self.position
    dx,dy = px - ox,py - oy
    for sp in self.listeMouvement:
      sx,sy = sp.rect.center
      dx = (px - sx) * t / 300.0
      dy = (py - sy) * t / 300.0
      # print dx,dy
      ndx,ndy = self.physicEngine.mouvement(sp,dx,dy)
      sp.direction = ndx,ndy
      sp.forcedMouvement(ndx,ndy)
      sx,sy = sp.rect.center
      self.object.positionnement(sx,sy)
      self.objectGroup.draw(self.particleGestionner.screen)
    return 1

  def positionnement(self,x,y):
    self.pos = x,y

  def deplacement(self,dx,dy):
    x,y = self.pos
    self.pos = x + dx, y + dy



class Crochet(Weapon):
  def __init__(self,pg,obstacle,eventGestionner,pe,camera,targetGroup):
    Weapon.__init__(self,pg,None,"crochet",0,"energy")
    self.particleGestionner = pg
    self.direction = 0,0
    self.eventGestionner = eventGestionner
    self.obstacle = obstacle
    self.position = 0,0
    self.physicEngine = pe
    self.icone,a = load_png("levitation.png")
    self.particleGestionner.attach(self)
    self.listeMouvement = []
    self.object = Object((0,0),"levitation2.png",0)
    self.objectGroup = pygame.sprite.Group(self.object)
    self.pointe = 0,0     # position de la pointe
    self.state = "rien"
    # on ajoute l'objet à la camera pour la mise à jour de la position de la pointe
    self.camera = camera
    self.camera.addDeplace(self)
    self.targetGroup = targetGroup
    self.longueur = 0
    # on précharge les images
    self.chainImage,r = load_png("chaine.png")
    self.pointeImage,r = load_png("pointe.png")
    self.force = None 
    self.forceValue = 20

  def cameraDeplace(self,dx,dy):
    if self.state == "attache" or self.state == "stationnaire":
      px,py = self.pointe
      self.pointe = px + dx, py + dy

  def getLoadLevel(self):
    return 1 

  def ChangeMode(self):
    if self.state == "stationnaire":
      self.state = "wait"
      self.perso.forces[1] = []
      self.force = None

  def getDescription(self):
    return "crochet",self.icone

  def setId(self,id):
    self.id = id

  def getMode(self):
    return "normal"

  def changeDirection(self,dx,dy):
    if self.state == "tirer" or self.state == "attache": return 0
    dx = float(dx)
    dy = float(dy)
    a = float(self.forceValue) / math.sqrt(dx*dx+dy*dy) 
    self.direction = (a*dx),(a*dy)

  def attach(self,perso):
    self.perso = perso

  def shoot(self):
    if self.state == "stationnaire":
      self.state = "attache"
    else:
      self.state = "tirer"
      self.pointe = self.pos # ition

  def unshoot(self):
    if self.state == "attache": 
      self.state = "stationnaire"
      dx,dy = self.direction
      self.force = Force("jump",dx,dy,self.physicEngine,type=1)
      self.force.addTo(self.perso.forces[1])
    elif self.state == "stationnaire":
      self.state = "wait"
      self.perso.forces[1] = []
      self.force = None
    else: 
      self.state = "wait" 
      self.force = None

  def update(self,t):
    self.position = self.eventGestionner.getMousePosition()
    if self.state == "tirer":
      dx,dy = self.direction
      px,py = self.pointe
      self.pointe = px + dx, py + dy
      drawLoadedImageLine(self.particleGestionner.screen,self.chainImage,self.pointeImage,self.pos,self.pointe)
      self.harmTarget(t)
      px,py = self.pos
      pox,poy = self.pointe
      for sp in self.obstacle.sprites():
        if sp.rect.collidepoint(self.pointe):
            self.state = "attache"
            self.longueur = (pox-px)**2 + (poy-py)**2
            break
      longueur = math.sqrt((pox-px)**2 + (poy-py)**2)
      if longueur > 350:
        self.state = "wait"
    elif self.state == "stationnaire":
      px,py = self.pos
      pox,poy = self.pointe
      dx,dy = pox -px, poy - py
      norme = math.sqrt(dx**2+dy**2)
      self.force.changeDirection((dx/norme,dy/norme)) 
      # on va essayer de retrouver la bonne longueur
      drawLoadedImageLine(self.particleGestionner.screen,self.chainImage,self.pointeImage,self.pos,self.pointe)
    elif self.state == "attache":
      drawLoadedImageLine(self.particleGestionner.screen,self.chainImage,self.pointeImage,self.pos,self.pointe)
      vx,vy = self.perso.vector
      pox,poy = self.pointe
      px,py = self.pos # a été mis à jour par le calcul pos
      dx,dy = pox - px, poy - py # self.direction
      n1 = math.sqrt(dx**2+dy**2)
      dx *= self.forceValue / n1
      dy *= self.forceValue / n1
      varx,vary = dx-vx,dy-vy # on vise à aller dans la direction du filin
      varx /= 10.0
      vary /= 10.0
      vectx,vecty = vx+varx,vy+vary
      idx,idy = self.perso.calcnewpos(self.perso.rect,(vectx,vecty),t,self.obstacle,update=1)
      px,py = self.pos # a été mis à jour par le calcul pos
      longueur = (pox-px)**2 + (poy-py)**2
    return 1


  def positionnement(self,x,y):
    self.pos = x,y

  def deplacement(self,dx,dy):
    x,y = self.pos
    self.pos = x + dx, y + dy
    px,py = self.pointe
    #self.pointe = px + dx , py + dy


  def harmTarget(self,time):
    for ob in self.targetGroup.sprites():
      if ob.rect.collidepoint(pint(self.pointe)):
        if 0: # self.blood:
          ob.looseLife(-1.3 * float(time),self.pointe,self.particleGestionner,self.targetGroup) 
        if 1: # not self.blood:
          ob.looseLife(-1.3 * float(time),self.pointe,self.particleGestionner,self.targetGroup) 
          self.blood = 1
          screen = self.particleGestionner.screen
          x,y = pint(self.pointe)
          dx,dy = self.direction
          f = abs(float(dx)) + abs(float(dy))
          dx = float(4) * float(dx) /  f
          dy = float(4) * float(dy) /  f
          direction = dx,dy # self.direction
          rate = 1
          ttl = 30
          range = (-1,2,-1,2)
          life = 400
          number = 10
          ps = ParticleSystem(screen,x,y,direction,rate,ttl,number,self.particleGestionner.background,range,life,back=0,type="blood")
          # back à 1 pour que le sang reste
          self.particleGestionner.attach(ps)
