#!/usr/bin/python
# coding: utf-8
#
# Brunie nicolas, War of Blood
#
 
 
try:
  import sys
  import random
  import math
  import os
  import pygame
  import socket
  from pygame.locals import *
  from Perso import Perso
  from Camera import Camera
  from Badguy import BadGuy
  from Weapons import Rifle, FireLauncher, ShotGun, JetPack, GrenadeLauncher, RocketLauncher
  from Environnement import Tourelle
  from Level import Level
  from Interface import Interface
  from MultiPlayerClient import *
  from Chemin import ThreadPath
  from GlobalGestionner import GlobalSystemGestionner
  from Avatar import Avatar
except ImportError, err:
  print "Impossible de charger le module. %s" % (err)
  sys.exit(2)


network = 0 # off : 0 | on : 1 
 
def main():
  global network
  # Initialisation du multiplayer
  # programme principal : etablissement de la connexion
  if "-net" in sys.argv:
    i = sys.argv.index("-net")
    if len(sys.argv) < i+3:
      print "argumant manquant -net hote PORT"
    host = sys.argv[i+1]
    port = int(sys.argv[i+2])
    connexion = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
    try:
      connexion.connect((host,port))
    except socket.error:
      print "la connexion a echouee."
      sys.exit()
    print "Connexion etablie avec le serveur."
    #th_E = ThreadEmission(connexion)
    th_R = ThreadReception(connexion)
    #th_E.start()
    th_R.start()

  """if network:
    print "hote ?"
    host = raw_input()
    print "l'hote sera %s " % host
    print "port ?"
    port = int(raw_input())
    print "le port sera %d " % port
    connexion = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
    try:
      connexion.connect((host,port))
    except socket.error:
      print "la connexion a echouee."
      sys.exit()
    print "Connexion etablie avec le serveur."
    th_E = ThreadEmission(connexion)
    #th_R = ThreadReception(connexion)
    th_E.start()
    #th_R.start()"""

  # Initialisation de la fenêtre d'affichage
  pygame.init()
  pygame.font.init()
  longueur = 1000
  largeur = 600
  screen = pygame.display.set_mode((longueur, largeur))
  pygame.display.set_caption('War Of Blood')

  # chargement de la police de caractère
  Font = pygame.font.Font(os.path.join("data", "FreeMono.ttf"), 24)
  # Remplissage de l'arrière-plan
  background = pygame.Surface(screen.get_size())
  background = background.convert()
  background.fill((255,255,255))

  # Initialisation du Perso
  ball = Perso() # (0,0),(0,0))
  avatar = Avatar()
  # intialisation
  dec = 100
  # Initialisation des sprites
  ballsprite = pygame.sprite.Group(ball)
  ballsprite.add(avatar)
  obstacle = pygame.sprite.Group()#brick0)

  # groupe de sprite immobile et sans interation
  decor = pygame.sprite.Group()
  
  # initialisation du niveau + apparition personnage principal
  level = Level()
  try:
    if sys.argv[1] == "-map" and len(sys.argv) >= 3:
      level.createLevelFromFile(sys.argv[2],obstacle,decor)
    else:
      level.createLevelFromFile("carte.map",obstacle,decor)
  except:
    print "impossible de charger la carte "
    try:
      level.createLevelFromFile("carte.map",obstacle,decor)
    except:
      print "impossible de charger la carte par défaut carte.map"
      raise Exception()
  ax,ay = level.getApparition()
  width,height,origine = level.getDimension()
  ball.deplacement(ax,ay)

  # Blitter le tout dans la fenêtre
  screen.blit(background, (0, 0))
  pygame.display.flip()

  # Initialisation de l'horloge
  clock = pygame.time.Clock()

  # mise en place de la caméra
  camera = Camera(screen,background,(longueur,largeur))
  camera.addMouvable(ballsprite)
  camera.addStatic(obstacle)
  camera.addStatic(decor)

  bg = BadGuy((500,0),(200,0),obstacle,ball)
  badGuyList = [bg]
  others = pygame.sprite.Group(bg)
  camera.addMouvable(others)
  # Gestionnaire d'effet de particule 
  pg = GlobalSystemGestionner(screen,background,0)

  #pg.attachToLayer(decor,3)
  #pg.attachToLayer(obstacle,6)
  
  pg.defineObstacle(obstacle)
  pg.defineCamera(camera)
  pg.definePerso(ball)
  #pg.attachToLayer(others,-1,type=4)
  pg.attachToLayer(ballsprite,1,type=7)
  # Initialisation de module path
  pathModule = ThreadPath(obstacle,ball,width,height,20,camera,origine)
  pathModule.start()

  # groupe sprite des objets destructible
  destructible = pygame.sprite.Group()
  tourelleGroup = pygame.sprite.Group()
  #pg.attachToLayer(destructible,0)

  # arme du personnage principal
  rifle = Rifle(pg,others)
  shotgun = ShotGun(pg,others)
  firelauncher = FireLauncher(pg,others)
  jetpack = JetPack(pg,others)
  grenadelauncher = GrenadeLauncher(pg,others,obstacle,tourelleGroup)
  rocketlauncher = RocketLauncher(pg,badGuyList,obstacle,pathModule,camera)

  ball.attach(firelauncher,(-13,0),(13,0),"Lance_Flamme.arme.png")
  ball.attach(rocketlauncher,(-10,-8),(10,-8),"lance_grenade_arme.png")
  ball.attach(rifle,(-16,-10),(16,-10),"riflem16.png")
  ball.attach(shotgun,(-18,-10),(18,-10),"fusil_a_pompe_arme.png")
  ball.attach(jetpack,(10,0),(-10,0),"jetpack.png",inversion=1)
  ball.attach(grenadelauncher,(-10,-8),(10,-8),"lance_grenade_arme.png")

  # Tourelle d'essai
  tx,ty = ball.rect.center
  tourelle = Tourelle((tx + 200,ty-100),None,"tourelle.socle1.png",(0,20),"tourelle.canon1.png",ball,pg)
  tourelleGroup.add(tourelle)

  #pg.attachToLayer(tourelleGroup,1,type=2)

  # autreGroup
  destructible.add(tourelle.getTourelle())
  ball.addDestructible(destructible)

  #otherEnv = pygame.sprite.Group()
  #pg.attachToLayer(otherEnv,


  #camera.addStatic(otherEnv)
  camera.addStatic(tourelleGroup)
  eventUpdate = []
  eventUpdate.append(jetpack)
  eventUpdate.append(grenadelauncher)
  # Boucle d'évènements

  totalTime = 0
  frame = 0

  # gestion de l'interface
  interface = Interface(screen,background,ball)
  interface.loadIconeList() # on charge la liste des icone, une fois que toutes les armes ont été attachées au personnage principal

  #pathModule = Path(obstacle,ball,width,height,20,camera)
  #pathModule.createRepresentation(origine[0],origine[1])
  #chemin = pathModule.findPath(300,150,800,300)
  #print chemin
  #chemin = pathModule.raffinePath(chemin)
  #chemin= [(300,150),(400,150)]
  chemin = [] 
  idPath = None
  tmp_update = 0
  tmpDoubleCmd = 0
  if 1: #try:
    while 1:
      # S'assurer que le jeu ne fonctionne pas à plus de 60 images par secondes
      time_between_frame = clock.tick(40)
      quit = 0
      for event in pygame.event.get():
        if event.type == QUIT:
          print "quit"
          if network: th_E.addQueue('')
          quit = 1
          break
        # mouvement de ma souris
        if event.type == MOUSEMOTION:
          px,py = event.pos
          ox,oy = ball.rect.center
          d = math.sqrt((px-ox)**2+(py-oy)**2)
          if d != 0: 
            dx = float((px-ox)) / float(d)
            dy = float(py-oy) / float(d)
            ball.changeDirection(dx,dy)
        # bouton souris
        if event.type == MOUSEBUTTONDOWN:
          if event.button == 1:
            ball.shoot()
          elif event.button == 3:
            ball.ChangeMode()
          elif event.button == 4:
            ball.changeWeapon(+1)
          elif event.button == 5:
            ball.changeWeapon(-1)
        if event.type == MOUSEBUTTONUP:
          if event.button == 1:
            ball.unShoot()
        if event.type == KEYDOWN:
          if event.key == K_i:
            interface.saveScreen()
          if event.key == K_p:
            i = raw_input("pause")
          if event.key == K_LEFT:
            ball.setMvt("left",obstacle)
          if event.key == K_r:
            ball.reload()
          if event.key == K_c:
            ball.changeWeapon()
          if event.key == K_SPACE:
            ball.shoot()
          elif event.key == K_RIGHT:
            ball.setMvt("right",obstacle)
          elif event.key == K_ESCAPE:
            if network: th_E.addQueue('')
            quit = 1
            break
          elif event.key == K_UP:
            if totalTime - tmpDoubleCmd < 1000:
              ball.bigJump(obstacle)
            else:
              ball.jump(obstacle)
            tmpDoubleCmd = totalTime
        elif event.type == KEYUP:
          if event.key == K_SPACE:
            ball.unShoot()
          if event.key == K_LEFT:  
            ball.unsetMvt("left")
          if event.key == K_RIGHT:  
            ball.unsetMvt("right")
          if event.key == K_q:
            camera.deplace(-10,0)
          elif event.key == K_d:
            camera.deplace(10,0)
          elif event.key == K_z:
            camera.deplace(0,10)
          elif event.key == K_s:
            camera.deplace(0,-10)
      if quit == 1:
        break
      tmp_update += time_between_frame
      """if tmp_update > 1000: #3000:
        tmp_update = 0
        #pathModule = Path(obstacle,ball,width,height,20,camera)
        #pathModule.createRepresentation(origine[0],origine[1])
        #print chemin
        px,py = ball.rect.center
        cx,cy = camera.pos
        #if idPath == None:
        #  print "lancement"
        if idPath != None:
          c = pathModule.getPath(idPath)
          if c != None:
            chemin = c
            idPath = pathModule.askPath(px-cx,py-cy,800,300)
        else:
          idPath = pathModule.askPath(px-cx,py-cx,800,300)
      #  chemin = pathModule.findPath(px-cx,py-cy,800,300)
      #  chemin = pathModule.raffinePath(chemin)
      #print px-cx,py-cy"""
      screen.blit(background,screen.get_rect(),screen.get_rect()) # ball.rect,ball.rect)
      #others.update(time_between_frame,obstacle)
      for i in eventUpdate:
        i.update(time_between_frame)
      ballsprite.update(time_between_frame, obstacle)
      camera.center(ball,time_between_frame)
      decor.draw(screen)
      #pg.update(time_between_frame)
      tourelleGroup.draw(screen)
      tourelleGroup.update(time_between_frame)
      #autreGroup.draw(screen)
      destructible.draw(screen)
      ballsprite.draw(screen)
      others.draw(screen)
      obstacle.draw(screen)
      #otherEnv.draw(screen)
      s3 = Font.render("Mode : " + ball.getMode(),0,(0,0,255))
      interface.render()
      ball.renderAttachement(screen)
      totalTime += time_between_frame
      frame += 1
      #th_E.addQueue(ball.getStringResume())
      # parsage des messages du réseau
      msg = th_R.getMsg()
      if msg != None:
        l = msg.split(' ')
        y = [l.remove('') for i in xrange(l.count(''))]
        avatar.positionnement(camera,int(l[1]),int(l[2]))
        avatar.changeDirection(float(l[3]),float(l[4]))
        #print l
      #pathModule.affiche(screen)
      #pathModule.pathModule.printChemin(chemin,screen)
      pygame.display.flip()
  #except e:
  #  print e
    # on rattrape toute les erreurs pour permettrent un arret correct des threads
  print (totalTime/frame)
  pathModule.arreter()
  th_R.end()
  if network:
    th_E.join()
    th_R.join()
  print "fin du prgm"
 
if __name__ == '__main__': main()
