#!/usr/bin/python
# coding: utf-8
#
# Brunie nicolas, War of Blood
#
 
try:
  import sys
  import random
  import math
  import os
  import pygame
  import socket
  from pygame.locals import *
  from Perso import Perso, GameOver
  from Camera import Camera
  from Badguy import BadGuy
  from Weapons import Rifle, FireLauncher, ShotGun, JetPack, GrenadeLauncher, RocketLauncher, Levitation, Crochet
  from Environnement import Tourelle
  from Level import Level
  from Interface import Interface
  from MultiPlayerClient import *
  from Chemin import ThreadPath
  from GlobalGestionner import GlobalSystemGestionner
  from NetworkModule import NetworkModule
  from Common import FusionGroup, Object, CompositeGroup, load_png
  from Caisse import Caisse, CaisseRessource, CaisseSoin, CaisseRifle
  # from Menu import MenuGestionner
  from Blast import BlastPhysicEngine
  from EventGestionner import EventGestionner
  from MenuGestionner import MenuGestionner
except ImportError, err:
  print "Impossible de charger le module. %s" % (err)
  sys.exit(2)


network = 0 # off : 0 | on : 1 
 
def main():
  global network
  # Initialisation du multiplayer
  # programme principal : etablissement de la connexion
  myNetwordId = None
  th_E = None
  th_R = None
  if "-net" in sys.argv:
    i = sys.argv.index("-net")
    if len(sys.argv) < i+3:
      print "argumant manquant -net hote PORT"
    host = sys.argv[i+1]
    port = int(sys.argv[i+2])
    connexion = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
    network = 1
    try:
      connexion.connect((host,port))
    except socket.error:
      print "la connexion a echouee."
      sys.exit()
    print "Connexion etablie avec le serveur."
    th_E = ThreadEmission(connexion)
    th_R = ThreadReception(connexion)
    th_E.start()
    th_R.start()
  # 

  # Initialisation de la fenêtre d'affichage
  pygame.init()
  pygame.font.init()
  longueur = 1000
  largeur = 600
  screen = pygame.display.set_mode((longueur, largeur)) # ,pygame.FULLSCREEN)
  pygame.display.set_caption('War Of Blood')
  
  # Initialisation de l'horloge
  clock = pygame.time.Clock()

  # chargement de la police de caractère
  Font = pygame.font.Font(os.path.join("data", "FreeMono.ttf"), 24)
  onMenu(Font,screen,(longueur,largeur),th_E,th_R,network,clock)
  # onGame(Font,screen,(longueur,largeur),th_E,th_R,network,clock)

class SortieJeu(Exception):
  pass

class BeginGame(Exception):
  pass

def launchGame(x):
  raise BeginGame()

def quitGame(x):
  raise SortieJeu

def onMenu(Font,screen,(longueur,largeur),th_E,th_R,network,clock):
  background = pygame.Surface(screen.get_size())
  background = background.convert()
  background.fill((255,255,255))
  menu = MenuGestionner("description.xml")   # chargement du schéma de menu
  # menu.setFunction("launchGame",onGame,(Font,screen,(longueur,largeur),th_E,th_R,network,clock))
  menu.setFunction("launchGame",launchGame,None)
  menu.setFunction("quit",quitGame,None)
  # parsage de l'interface
  menu.createInterface()
  try:
    while 1:
      try:
        while 1:
          time_between_frame = clock.tick(40)
          eventList = pygame.event.get()
          if not menu.renderInterface(screen,time_between_frame,eventList):
            return 0
          pygame.display.flip()
      except BeginGame:
        try:
          onGame((Font,screen,(longueur,largeur),th_E,th_R,network,clock))
        except GameOver:
          print "game over"
  except SortieJeu:
    print "sortie du jeu"

def onGame((Font,screen,(longueur,largeur),th_E,th_R,network,clock)):
  #Initialisation du moteur physique Blast
  PhysicEngine = BlastPhysicEngine()

  networkList = []

  # Remplissage de l'arrière-plan
  backgroundChargement,r = load_png("chargement.png")
  background,r = load_png("background.png")
  # Blitter le tout dans la fenêtre
  screen.blit(backgroundChargement, (0, 0))
  pygame.display.flip()

  # Initialisation du Perso
  ball = Perso(PhysicEngine) 
  ballsprite = pygame.sprite.Group(ball)

  # groupe de sprite immobile et sans interation
  decor = pygame.sprite.Group()
  # groupe des BadGuys
  others = pygame.sprite.Group()
  # groupe des sprites de caisse
  caisseGroup = pygame.sprite.Group()
  # groupe d'obstacle
  obstacle = pygame.sprite.Group()#brick0)
  # groupe d'avatar (ghost réseau)
  avatarGroup = pygame.sprite.Group()
  
  # Moteur Physique (simplissime) Blast
  PhysicEngine.addObstacleGroup(obstacle)

  # Gestionnaire d'effet et de mise à jour (dont particules)
  pg = GlobalSystemGestionner(screen,background,0)


  # initialisation du niveau + apparition personnage principal
  level = Level()
  try:
    if sys.argv[1] == "-map" and len(sys.argv) >= 3:
      level.createLevelFromFile(sys.argv[2],obstacle,decor,PhysicEngine,FusionGroup(ballsprite,others),caisseGroup,others,ball,pg)
    else:
      level.createLevelFromFile("carte.map",obstacle,decor,PhysicEngine,FusionGroup(ballsprite,others),caisseGroup,others,ball,pg)
  except:
    print "impossible de charger la carte "
    #try:
    level.createLevelFromFile("carte.map",obstacle,decor,PhysicEngine,FusionGroup(ballsprite,others),caisseGroup,others,ball,pg)
    #except:
    #  print "impossible de charger la carte par défaut carte.map"
    #  raise Exception()
  ax,ay = level.getApparition()
  width,height,origine = level.getDimension()
  ball.deplacement(ax,ay,initial=1)

  # mise en place de la caméra
  camera = Camera(screen,background,(longueur,largeur))
  camera.addMouvable(ballsprite)
  camera.addMouvable(avatarGroup)
  camera.addStatic(obstacle)
  camera.addStatic(decor)
  
  bx,by = ball.globalpos

  cx,cy = camera.pos
  gx,gy = 600,200
  bg = BadGuy((gx-cx,gy-cy),(gx,gy),obstacle,ball,PhysicEngine,pg)
  bg2 = BadGuy((gx-cx+100,gy-cy),(gx+100,gy),obstacle,ball,PhysicEngine,pg)
  bg3 = BadGuy((bx-cx+300,by-cy),(bx+300,by),obstacle,ball,PhysicEngine,pg)
  others.add(bg,bg2,bg3)
  camera.addMouvable(others)

  pg.attachToLayer(decor,-1,type=0)

  networkList.append(ball)
  # networkList.append(bg3)

  targetGroup = FusionGroup(avatarGroup,others)

  # Caisse bougeable
  caisse = Caisse(obstacle,FusionGroup(ballsprite,others),(bx+100,by+100,cx,cy),PhysicEngine)
  caisse2 = Caisse(obstacle,FusionGroup(ballsprite,others),(bx+200,by,cx,cy),PhysicEngine)
  print "vrai caisse %d %d %d %d " % (bx+200,by,cx,cy) 
  caisseGroup.add(caisse,caisse2)
  camera.addMouvable(caisseGroup)
  pg.attachToLayer(caisseGroup,0,type=2)

  PhysicEngine.addMovableGroup(caisseGroup)
  PhysicEngine.addMovableGroup(ballsprite)
  PhysicEngine.addMovableGroup(others)

  # Caisse ressource
  caisseRessource1 = CaisseRessource(obstacle,ballsprite,(bx-100,by+100,cx,cy),PhysicEngine,"bullet","caisse_munition.png",pg)
  caisseRessource2 = CaisseSoin(obstacle,ballsprite,(bx-200,by+100,cx,cy),PhysicEngine,pg)
  caisseRessource3 = CaisseRifle(obstacle,ballsprite,(bx+300,by+100,cx,cy),PhysicEngine,pg,targetGroup)
  caisseRessourceGroup = CompositeGroup(caisseRessource1,caisseRessource2,caisseRessource3)
  camera.addMouvable(caisseRessourceGroup)
  pg.attachToLayer(caisseRessourceGroup,0,type=2)

  if network:
    networkModule = NetworkModule(camera,avatarGroup,pg,PhysicEngine)
    th_E.addQueue("<getid>")
    # th_E.addQueue("<getid>")
    networkModule.addIdWaiting(ball)
    # networkModule.addIdWaiting(bg3)
  
  pg.defineObstacle(obstacle)
  pg.defineCamera(camera)
  pg.definePerso(ball)
  pg.attachToLayer(ballsprite,1,type=7)
  pg.attachToLayer(others,1,type=4)
  pg.attachToLayer(avatarGroup,2,type=8)
  # Initialisation de module path
  pathModule = ThreadPath(obstacle,ball,width,height,20,camera,origine)
  pathModule.start()

  # groupe sprite des objets destructible
  destructible = pygame.sprite.Group()
  tourelleGroup = pygame.sprite.Group()

  # arme du personnage principal
  #rifle = Rifle(pg,targetGroup)
  shotgun = ShotGun(pg,targetGroup) # targetGroup au lieu de others
  firelauncher = FireLauncher(pg,targetGroup)
  jetpack = JetPack(pg,others)
  grenadelauncher = GrenadeLauncher(pg,others,obstacle,tourelleGroup)

  ball.attach(firelauncher,(-13,0),(13,0),Object((0,0),"Lance_Flamme.arme.png"))
  #ball.attach(rifle,(-16,-10),(16,-10),Object((0,0),"riflem16.png"))
  ball.attach(shotgun,(-18,-10),(18,-10),Object((0,0),"fusil_a_pompe_arme.png"))
  ball.attach(jetpack,(10,0),(-10,0),Object((0,0),"jetpack.png"),inversion=1)
  ball.attach(grenadelauncher,(-10,-8),(10,-8),Object((0,0),"lance_grenade_arme.png"))

  # Tourelle d'essai
  tx,ty = ball.rect.center
  pg.attachToLayer(tourelleGroup,2,type=2)

  ball.addDestructible(destructible)
  pg.attachToLayer(destructible,0,type=0)

  camera.addStatic(tourelleGroup)
  eventUpdate = []
  eventUpdate.append(jetpack)
  eventUpdate.append(grenadelauncher)
  # Boucle d'évènements

  totalTime = 0
  frame = 0

  # gestion de l'interface
  interface = Interface(screen,background,ball)

  chemin = [] 
  idPath = None
  tmp_update = 0
  tmpDoubleCmd = 0
  
  # Initialisation du gestionnaire d'evenement
  eventGestionner = EventGestionner(ball,camera,interface,obstacle)
  levitation = Levitation(pg,caisseGroup,eventGestionner,PhysicEngine)
  ball.attach(levitation,(0,0),(0,0),Object((0,0),"levitation.png"))

  rocketlauncher = RocketLauncher(pg,others,obstacle,pathModule,camera,eventGestionner)
  ball.attach(rocketlauncher,(-10,-8),(10,-8),Object((0,0),"lance_grenade_arme.png"))

  crochet = Crochet(pg,obstacle,eventGestionner,PhysicEngine,camera,others)
  ball.attach(crochet,(-10,-8),(10,-8),Object((0,0),"lance_grenade_arme.png"))

  interface.loadIconeList() # on charge la liste des icone, une fois que toutes les armes ont été attachées au personnage principal

  try:
    while 1:
      # S'assurer que le jeu ne fonctionne pas à plus de 60 images par secondes
      time_between_frame = clock.tick(40)
      if not eventGestionner.update(time_between_frame):
        if network:
          th_E.addQueue('')
        print "quit"
        break
      tmp_update += time_between_frame
      screen.blit(background,screen.get_rect(),screen.get_rect()) # ball.rect,ball.rect)
      for i in eventUpdate:
        i.update(time_between_frame)
      pg.update(time_between_frame)
      destructible.draw(screen)
      obstacle.draw(screen)
      s3 = Font.render("Mode : " + ball.getMode(),0,(0,0,255))
      interface.render(time_between_frame)
      # print "bgp %d %d " % ball.globalpos
      totalTime += time_between_frame
      frame += 1
      if network:
        for character in networkList:
          if character.networkId == None: continue
          head = character.getHeadResume()
          for s in character.getListResume():
            th_E.addQueue("<"+head + " " + s + ">")
          character.listResume = []
        # mise à jour des avatars
        for av in avatarGroup.sprites():
          head = av.getHeadResume()
          for s in av.getListResume():
            th_E.addQueue("<"+head + " " + s + ">")
          av.listResume = []
      if network:
        msg = th_R.getMsg()
        networkModule.parseMsg(msg,avatarGroup)
      pygame.display.flip()
  except GameOver,SortieJeu:
    print "exception attrapée"
  finally:
    print (totalTime/frame)
    pathModule.arreter()
    if network:
      th_R.end()
      th_E.end()
    if network:
      th_E.join()
      th_R.join()
    print "fin du prgm"
 
if __name__ == '__main__': main()
